% MB_Plot_3D_Anderson_Creek_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% anderson creek fault %%

dip = 80;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Anderson_Creek_Fault_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% southern fault leg 3000m spacing
for i=1:3
    x(d+1+3*(i-1):d+3*i) = x(1:3)+3000*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+3*(i-1):d+3*i) = y(1:3)-3000*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+3*(i-1):d+3*i) = -3000*i;
end

d = numel(x);
% southern L. medium fault leg 1500m spacing
for i=1:3
    x(d+1+1*(i-1):d+1*i) = x(4)+1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = y(4)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -1500*i;
end
d = numel(x);
% e = -z(numel(z));
for i=1:2
        x(d+1+1*(i-1):d+1*i) = x(5)+(1500*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+1*(i-1):d+1*i) = y(5)-(1500*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+1*(i-1):d+1*i) = -1500*i;
end

d = numel(x);
% southern U. medium fault leg 600m spacing
for i=1:3
    x(d+1+1*(i-1):d+1*i) = x(6)+600*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = y(6)-600*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -600*i;
end

d = numel(x);
% middle fault leg 300m spacing
% for i=1:13
%         x(d+1+80*(i-1):d+80*i) = x(7:86)+300*i*cos(dip*(pi/180))*sin(theta);
%         y(d+1+80*(i-1):d+80*i) = y(7:86)-300*i*cos(dip*(pi/180))*cos(theta);
%         z(d+1+80*(i-1):d+80*i) = -300*i;
% end
% d = numel(x);
% e = -z(numel(z));

for i=1:3
        x(d+1+80*(i-1):d+80*i) = x(7:86)+300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+80*(i-1):d+80*i) = y(7:86)-300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+80*(i-1):d+80*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));

for i=1
        x(d+1+40*(i-1):d+40*i) = x(7:2:86)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+40*(i-1):d+40*i) = y(7:2:86)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+40*(i-1):d+40*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
set = [7:3:86];set(16) = 51;
for i=1
        x(d+1+27*(i-1):d+27*i) = x(set)+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+27*(i-1):d+27*i) = y(set)-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+27*(i-1):d+27*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+12*(i-1):d+12*i) = [x(7:8:86);x(85);x(51)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+12*(i-1):d+12*i) = [y(7:8:86);y(85);y(51)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+12*(i-1):d+12*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+12*(i-1):d+12*i) = [x(7:8:86);x(85);x(51)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+12*(i-1):d+12*i) = [y(7:8:86);y(85);y(51)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+12*(i-1):d+12*i) = -e-2400*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+10*(i-1):d+10*i) = [x(7:10:86);x(85);x(51)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+10*(i-1):d+10*i) = [y(7:10:86);y(85);y(51)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+10*(i-1):d+10*i) = -e-3000*i;
end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1:3
    x(d+1+1*(i-1):d+1*i) = x(87)+600*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = y(87)-600*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -600*i;
end

d = numel(x);
% northern U. medium fault leg 1500m spacing
for i=1:3
    x(d+1+1*(i-1):d+1*i) = x(88)+1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = y(88)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -1500*i;
end

d = numel(x);
% northern fault leg 3000m spacing
for i=1:3
    x(d+1+3*(i-1):d+3*i) = x(89:91)+3000*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+3*(i-1):d+3*i) = y(89:91)-3000*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+3*(i-1):d+3*i) = -3000*i;
end


XYZacf(:,1) = x;XYZacf(:,2) = y;XYZacf(:,3) = z;

CON=Delaunay2_5D(XYZacf);

figure
plot3(XYZacf(:,1),XYZacf(:,2),XYZacf(:,3),'ko');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
% xlim([0 1000])
% ylim([0 6500])
% zlim([-3600 0])
title('Anderson Creek Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZacf([CON(i,:) CON(i,1)],1),XYZacf([CON(i,:) CON(i,1)],2),XYZacf([CON(i,:) CON(i,1)],3),'b-')
end

[tnacf,nvecacf] = PlotTriNormals(CON,XYZacf,convention);

% Translate back to UTM
XYZacf(:,1) = XYZacf(:,1) + xo;
XYZacf(:,2) = XYZacf(:,2) + yo;