% MB_Plot_3D_Baker_Lake_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% baker lake fault %%

dip = 80;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Baker_Lake_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:8:17);xs(26)];
y = [ys(1:8:17);ys(26)];
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+7*(i-1):d+7*i) = [xs(1:4:21);xs(26)]+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+7*(i-1):d+7*i) = [ys(1:4:21);ys(26)]-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+7*(i-1):d+7*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+13*(i-1):d+13*i) = [xs(1:2:23);xs(26)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+13*(i-1):d+13*i) = [ys(1:2:23);ys(26)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+13*(i-1):d+13*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+26*(i-1):d+26*i) = xs(1:26)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+26*(i-1):d+26*i) = ys(1:26)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+26*(i-1):d+26*i) = -(e+300*i);
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+13*(i-1):d+13*i) = [xs(1:2:23);xs(26)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+13*(i-1):d+13*i) = [ys(1:2:23);ys(26)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+13*(i-1):d+13*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+7*(i-1):d+7*i) = [xs(1:4:21);xs(26)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+7*(i-1):d+7*i) = [ys(1:4:21);ys(26)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+7*(i-1):d+7*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+4*(i-1):d+4*i) = [xs(1:8:17);xs(26)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = [ys(1:8:17);ys(26)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+4*(i-1):d+4*i) = [xs(1:8:17);xs(26)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = [ys(1:8:17);ys(26)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -e-2400*i;
end



XYZblf(:,1) = x;XYZblf(:,2) = y;XYZblf(:,3) = z;

CON=Delaunay2_5D(XYZblf);

figure
plot3(XYZblf(:,1),XYZblf(:,2),XYZblf(:,3),'ko');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
% xlim([0 1000])
% ylim([0 6500])
% zlim([-3600 0])
title('Baker Lake Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZblf([CON(i,:) CON(i,1)],1),XYZblf([CON(i,:) CON(i,1)],2),XYZblf([CON(i,:) CON(i,1)],3),'b-')
end

[tnblf,nvecblf] = PlotTriNormals(CON,XYZblf,convention);

% Translate back to UTM
XYZblf(:,1) = XYZblf(:,1) + xo;
XYZblf(:,2) = XYZblf(:,2) + yo;