% MB_Plot_3D_Barometer_Mountain_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% barometer mountain fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Barometer_Mountain_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:4:12);xs(12)];x(2) = xs(6);
y = [ys(1:4:12);ys(12)];y(2) = ys(6);
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
theta = 75*(pi/180);

d = numel(x);
% middle fault leg 300m spacing
set = [1:3:12];set(3) = 6;set(4) = 9;
for i=1
        x(d+1+5*(i-1):d+5*i) = [xs(set);xs(12)]+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = [ys(set);ys(12)]-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:2:12];set(4) = 8;
for i=1
        x(d+1+8*(i-1):d+8*i) = [xs(set);xs(12);xs(6)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+8*(i-1):d+8*i) = [ys(set);ys(12);ys(6)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+8*(i-1):d+8*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+12*(i-1):d+12*i) = xs(1:12)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+12*(i-1):d+12*i) = ys(1:12)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+12*(i-1):d+12*i) = -(e+300*i);
end


% d = numel(x);
% e = -z(numel(z));
% set = [1:4:12];set(2) = 6;
% for i=1
%         x(d+1+4*(i-1):d+4*i) = [x(set);x(12)]+(e+1500*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+4*(i-1):d+4*i) = [y(set);y(12)]-(e+1500*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+4*(i-1):d+4*i) = -e-1500*i;
% end


% Triangular Mesh
XYZbmf(:,1) = x;XYZbmf(:,2) = y;XYZbmf(:,3) = z;

CON=Delaunay2_5D(XYZbmf);

figure
plot3(XYZbmf(:,1),XYZbmf(:,2),XYZbmf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Barometer Mountain Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZbmf([CON(i,:) CON(i,1)],1),XYZbmf([CON(i,:) CON(i,1)],2),XYZbmf([CON(i,:) CON(i,1)],3),'b-')
end

[tnbmf,nvecbmf] = PlotTriNormals(CON,XYZbmf,convention);

% Translate back to UTM
XYZbmf(:,1) = XYZbmf(:,1) + xo;
XYZbmf(:,2) = XYZbmf(:,2) + yo;