% MB_Plot_3D_Chilliwack_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Chilliwack River fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Chilliwack_River_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:3);xs(6);xs(13)];
y = [ys(1:3);ys(6);ys(13)];
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% northern fault leg 3000m spacing
for i=1:3
    x(d+1+2*(i-1):d+2*i) = xs(1:2)+3000*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = ys(1:2)-3000*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -3000*i;
end

d = numel(x);
% northern U. medium fault leg 1500m spacing
for i=1:4
    x(d+1+1*(i-1):d+1*i) = xs(3)+1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(3)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -1500*i;
end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1:3
    x(d+1+2*(i-1):d+2*i) = xs(4:5)+(1800+600*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = ys(4:5)-(1800+600*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -(1800+600*i);
end

d = numel(x);
% middle fault leg 300m spacing
set = [6:3:13];set(3) = 13;
for i=1
        x(d+1+3*(i-1):d+3*i) = [xs(set)]+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+3*(i-1):d+3*i) = [ys(set)]-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+3*(i-1):d+3*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+5*(i-1):d+5*i) = [xs(6:2:13);xs(13)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = [ys(6:2:13);ys(13)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+8*(i-1):d+8*i) = xs(6:13)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+8*(i-1):d+8*i) = ys(6:13)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+8*(i-1):d+8*i) = -(e+300*i);
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+5*(i-1):d+5*i) = [xs(6:2:13);xs(13)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = [ys(6:2:13);ys(13)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
set = [6:3:13];set(3) = 13;
for i=1
        x(d+1+3*(i-1):d+3*i) = [xs(set)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+3*(i-1):d+3*i) = [ys(set)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+3*(i-1):d+3*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+3*(i-1):d+3*i) = [xs(set)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+3*(i-1):d+3*i) = [ys(set)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+3*(i-1):d+3*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+2*(i-1):d+2*i) = [xs(6);xs(13)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+2*(i-1):d+2*i) = [ys(6);ys(13)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+2*(i-1):d+2*i) = -e-2400*i;
end

% Triangular Mesh
XYZcrf(:,1) = x;XYZcrf(:,2) = y;XYZcrf(:,3) = z;

CON=Delaunay2_5D(XYZcrf);

figure
plot3(XYZcrf(:,1),XYZcrf(:,2),XYZcrf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Chilliwack River Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZcrf([CON(i,:) CON(i,1)],1),XYZcrf([CON(i,:) CON(i,1)],2),XYZcrf([CON(i,:) CON(i,1)],3),'b-')
end

[tncrf,nveccrf] = PlotTriNormals(CON,XYZcrf,convention);

% Translate back to UTM
XYZcrf(:,1) = XYZcrf(:,1) + xo;
XYZcrf(:,2) = XYZcrf(:,2) + yo;