% MB_Plot_3D_Damfino_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Damfino fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Damfino_Fault_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
% dataACF = importdata('Anderson_Creek_Fault_points.csv');
% dx = dataACF.data(91,1) - dataACF.data(1,1);
% dy = dataACF.data(91,2) - dataACF.data(1,2);
% theta = atan(dy/dx);
theta = 75*(pi/180);

d = numel(x);
% northern fault leg 3000m spacing
for i=1:3
    x(d+1+3*(i-1):d+3*i) = x(1:3)+3000*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+3*(i-1):d+3*i) = y(1:3)-3000*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+3*(i-1):d+3*i) = -3000*i;
end

d = numel(x);
% northern U. medium fault leg 1500m spacing
for i=1:4
    x(d+1+1*(i-1):d+1*i) = x(4)+1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = y(4)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -1500*i;
end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1:3
    x(d+1+2*(i-1):d+2*i) = x(5:6)+600*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = y(5:6)-600*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -600*i;
end
d = numel(x);
x(d+1) = x(6)+5000*cos(dip*(pi/180))*sin(theta);
y(d+1) = y(6)-5000*cos(dip*(pi/180))*cos(theta);
z(d+1) = -5000;
d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+43*(i-1):d+43*i) = x(7:49)+300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+43*(i-1):d+43*i) = y(7:49)-300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+43*(i-1):d+43*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+22*(i-1):d+22*i) = x(7:2:49)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+22*(i-1):d+22*i) = y(7:2:49)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+22*(i-1):d+22*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
set = [7:3:49];set(2) = 9;
for i=1
        x(d+1+15*(i-1):d+15*i) = x(set)+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+15*(i-1):d+15*i) = y(set)-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+15*(i-1):d+15*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+8*(i-1):d+8*i) = [x(7:8:49);x(9);x(49)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+8*(i-1):d+8*i) = [y(7:8:49);y(9);y(49)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+8*(i-1):d+8*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
set = [7:8:49];set(1) = 9;
for i=1
        x(d+1+7*(i-1):d+7*i) = [x(set);x(49)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+7*(i-1):d+7*i) = [y(set);y(49)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+7*(i-1):d+7*i) = -e-2400*i;
end
d = numel(x);
e = -z(numel(z));
set = [7:10:49];set(1) = 9;
for i=1
        x(d+1+6*(i-1):d+6*i) = [x(set);x(49)]+(e+3000*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+6*(i-1):d+6*i) = [y(set);y(49)]-(e+3000*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+6*(i-1):d+6*i) = -e-3000*i;
end


% Triangular Mesh
XYZdf(:,1) = x;XYZdf(:,2) = y;XYZdf(:,3) = z;

CON=Delaunay2_5D(XYZdf);

figure
plot3(XYZdf(:,1),XYZdf(:,2),XYZdf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Damfino Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZdf([CON(i,:) CON(i,1)],1),XYZdf([CON(i,:) CON(i,1)],2),XYZdf([CON(i,:) CON(i,1)],3),'b-')
end

[tndf,nvecdf] = PlotTriNormals(CON,XYZdf,convention);

% Translate back to UTM
XYZdf(:,1) = XYZdf(:,1) + xo;
XYZdf(:,2) = XYZdf(:,2) + yo;