% MB_Plot_3D_Damfino_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Damfino fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Damfino_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:4);xs(7:8:49)];x(5) = xs(9);x(10) = xs(49);
y = [ys(1:4);ys(7:8:49)];y(5) = ys(9);y(10) = ys(49);
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
theta = 75*(pi/180);

d = numel(x);
% northern fault leg 3000m spacing
for i=1:3
    x(d+1+3*(i-1):d+3*i) = xs(1:3)+3000*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+3*(i-1):d+3*i) = ys(1:3)-3000*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+3*(i-1):d+3*i) = -3000*i;
end

d = numel(x);
% northern U. medium fault leg 1500m spacing
for i=1:4
    x(d+1+1*(i-1):d+1*i) = xs(4)+1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(4)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -1500*i;
end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1:3
    x(d+1+2*(i-1):d+2*i) = xs(5:6)+(1800+600*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = ys(5:6)-(1800+600*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -(1800+600*i);
end
% d = numel(x);
% x(d+1) = xs(6)+5000*cos(dip*(pi/180))*sin(theta);
% y(d+1) = ys(6)-5000*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -5000;
d = numel(x);

% middle fault leg 300m spacing
for i=1
        x(d+1+13*(i-1):d+13*i) = [xs(7:4:49);xs(9);xs(49)]+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+13*(i-1):d+13*i) = [ys(7:4:49);ys(9);ys(49)]-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+13*(i-1):d+13*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+22*(i-1):d+22*i) = xs(7:2:49)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+22*(i-1):d+22*i) = ys(7:2:49)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+22*(i-1):d+22*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+43*(i-1):d+43*i) = xs(7:49)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+43*(i-1):d+43*i) = ys(7:49)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+43*(i-1):d+43*i) = -(e+300*i);
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+22*(i-1):d+22*i) = xs(7:2:49)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+22*(i-1):d+22*i) = ys(7:2:49)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+22*(i-1):d+22*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
set = [7:3:49];set(2) = 9;
for i=1
        x(d+1+15*(i-1):d+15*i) = xs(set)+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+15*(i-1):d+15*i) = ys(set)-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+15*(i-1):d+15*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+8*(i-1):d+8*i) = [xs(7:8:49);xs(9);xs(49)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+8*(i-1):d+8*i) = [ys(7:8:49);ys(9);ys(49)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+8*(i-1):d+8*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
set = [7:8:49];set(1) = 9;
for i=1
        x(d+1+7*(i-1):d+7*i) = [xs(set);xs(49)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+7*(i-1):d+7*i) = [ys(set);ys(49)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+7*(i-1):d+7*i) = -e-2400*i;
end
% d = numel(x);
% e = -z(numel(z));
% set = [7:10:49];set(1) = 9;
% for i=1
%         x(d+1+6*(i-1):d+6*i) = [x(set);x(49)]+(e+3000*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+6*(i-1):d+6*i) = [y(set);y(49)]-(e+3000*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+6*(i-1):d+6*i) = -e-3000*i;
% end


% Triangular Mesh
XYZdf(:,1) = x;XYZdf(:,2) = y;XYZdf(:,3) = z;

CON=Delaunay2_5D(XYZdf);

figure
plot3(XYZdf(:,1),XYZdf(:,2),XYZdf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Damfino Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZdf([CON(i,:) CON(i,1)],1),XYZdf([CON(i,:) CON(i,1)],2),XYZdf([CON(i,:) CON(i,1)],3),'b-')
end

[tndf,nvecdf] = PlotTriNormals(CON,XYZdf,convention);

% Translate back to UTM
XYZdf(:,1) = XYZdf(:,1) + xo;
XYZdf(:,2) = XYZdf(:,2) + yo;