% MB_Plot_3D_Darrington_Devils.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% darrington-devils mountain fault %%

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Darrington-Devils_Mountain_Fault_points.csv');
% x surface points
dx = data.data(1,1)-data.data(2,1);
x = [data.data(2,1):dx/11:data.data(1,1)];
x = sort(x,'descend');
dx = data.data(2,1)-data.data(3,1);
x(13:19) = [data.data(3,1):dx/7:data.data(2,1)-dx/7];
x(13:19) = sort(x(13:19),'descend');
x=x';
% y surface points
dy = data.data(2,2)-data.data(1,2);
y = [data.data(1,2):dy/11:data.data(2,2)];
dy = data.data(3,2)-data.data(2,2);
y(13:19) = [data.data(2,2)+dy/7:dy/7:data.data(3,2)];
y=y';
% z surface points
z = -ones(numel(x),1);

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

% 5000m spacing
x(20:38) = x(1:19)+5000*cos(80*(pi/180))*sin(theta);
x(39:57) = x(1:19)+10000*cos(80*(pi/180))*sin(theta);
x(58:76) = x(1:19)+15000*cos(80*(pi/180))*sin(theta);
y(20:38) = y(1:19)-5000*cos(80*(pi/180))*cos(theta);
y(39:57) = y(1:19)-10000*cos(80*(pi/180))*cos(theta);
y(58:76) = y(1:19)-15000*cos(80*(pi/180))*cos(theta);
z(20:38) = -5000;
z(39:57) = -10000;
z(58:76) = -15000;


XYZddmf(:,1) = x;XYZddmf(:,2) = y;XYZddmf(:,3) = z;

CON=Delaunay2_5D(XYZddmf);

figure
plot3(XYZddmf(:,1),XYZddmf(:,2),XYZddmf(:,3),'ko');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
% xlim([0 1000])
% ylim([0 6500])
% zlim([-3600 0])
title('Darrington-Devils Mountain Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZddmf([CON(i,:) CON(i,1)],1),XYZddmf([CON(i,:) CON(i,1)],2),XYZddmf([CON(i,:) CON(i,1)],3),'b-')
end

[tnddmf,nvecddmf] = PlotTriNormals(CON,XYZddmf,convention);

% Translate back to UTM
XYZddmf(:,1) = XYZddmf(:,1) + xo;
XYZddmf(:,2) = XYZddmf(:,2) + yo;