% MB_Plot_3D_Gallop_Creek_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Gallop Creek fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Gallop_Creek_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = xs(1:8:41);
y = ys(1:8:41);
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle
dataTC = importdata('Thompson_Creek_Fault_points.csv');
dx = dataTC.data(1,1) - dataTC.data(31,1);
dy = dataTC.data(31,2) - dataTC.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+11*(i-1):d+11*i) = xs(1:4:41)+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+11*(i-1):d+11*i) = ys(1:4:41)+1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+11*(i-1):d+11*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+21*(i-1):d+21*i) = xs(1:2:41)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+21*(i-1):d+21*i) = ys(1:2:41)+(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+21*(i-1):d+21*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+41*(i-1):d+41*i) = xs(1:41)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+41*(i-1):d+41*i) = ys(1:41)+(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+41*(i-1):d+41*i) = -(e+300*i);
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+21*(i-1):d+21*i) = xs(1:2:41)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+21*(i-1):d+21*i) = ys(1:2:41)+(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+21*(i-1):d+21*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+11*(i-1):d+11*i) = xs(1:4:41)+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+11*(i-1):d+11*i) = ys(1:4:41)+(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+11*(i-1):d+11*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+11*(i-1):d+11*i) = xs(1:4:41)+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+11*(i-1):d+11*i) = ys(1:4:41)+(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+11*(i-1):d+11*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+6*(i-1):d+6*i) = xs(1:8:41)+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+6*(i-1):d+6*i) = ys(1:8:41)+(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+6*(i-1):d+6*i) = -e-2400*i;
end


% Triangular Mesh
XYZgcf(:,1) = x;XYZgcf(:,2) = y;XYZgcf(:,3) = z;

CON=Delaunay2_5D(XYZgcf);

figure
plot3(XYZgcf(:,1),XYZgcf(:,2),XYZgcf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Gallop Creek Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZgcf([CON(i,:) CON(i,1)],1),XYZgcf([CON(i,:) CON(i,1)],2),XYZgcf([CON(i,:) CON(i,1)],3),'b-')
end

[tngcf,nvecgcf] = PlotTriNormals(CON,XYZgcf,convention);

% Translate back to UTM
XYZgcf(:,1) = XYZgcf(:,1) + xo;
XYZgcf(:,2) = XYZgcf(:,2) + yo;

% %% Northern Leg of Glacier Extensional Fault
% 
% dip = 50;
% 
% GEX = importdata('Glacier_Extensional_Fault1_points.csv');
% % x surface points
% X = GEX.data(:,1);
% % y surface points
% Y = GEX.data(:,2);
% % z surface points
% Z = -ones(numel(X),1);
% 
% figure
% plot(X,Y,'k.')
% axis equal
% 
% % projection angle
% theta = 10*(pi/180);
% 
% % d = numel(X-1);
% % % northern fault leg 3000m spacing
% % for i=1
% %     X(d+1+2*(i-1):d+2*i) = X(1:2)-3000*i*cos(dip*(pi/180))*cos(theta);
% %     Y(d+1+2*(i-1):d+2*i) = Y(1:2)+3000*i*cos(dip*(pi/180))*sin(theta);
% %     Z(d+1+2*(i-1):d+2*i) = -3000*i;
% % end
% 
% d = numel(X-1);
% % northern U. medium fault leg 1500m spacing
% for i=1
%     X(d+1+4*(i-1):d+4*i) = X(1:4)-1200*i*cos(dip*(pi/180))*cos(theta);
%     Y(d+1+4*(i-1):d+4*i) = Y(1:4)+1200*i*cos(dip*(pi/180))*sin(theta);
%     Z(d+1+4*(i-1):d+4*i) = -1200*i;
% end
% 
% d = numel(X);
% % northern L. medium fault leg 600m spacing
% for i=1:2
%     X(d+1+2*(i-1):d+2*i) = X(5:6)-600*i*cos(dip*(pi/180))*cos(theta);
%     Y(d+1+2*(i-1):d+2*i) = Y(5:6)+600*i*cos(dip*(pi/180))*sin(theta);
%     Z(d+1+2*(i-1):d+2*i) = -600*i;
% end
% 
% d = numel(X);
% % middle fault leg 300m spacing
% for i=1:4
%         X(d+1+78*(i-1):d+78*i) = X(7:84)-300*i*cos(dip*(pi/180))*cos(theta);
%         Y(d+1+78*(i-1):d+78*i) = Y(7:84)+300*i*cos(dip*(pi/180))*sin(theta);
%         Z(d+1+78*(i-1):d+78*i) = -300*i;
% end
% 
% d = numel(X);
% for i=1:4
%         X(d+1+2*(i-1):d+2*i) = [X(84:85)]-(300*i)*cos(dip*(pi/180))*sin(30*(pi/180));
%         Y(d+1+2*(i-1):d+2*i) = [Y(84:85)]-(300*i)*cos(dip*(pi/180))*cos(30*(pi/180));
%         Z(d+1+2*(i-1):d+2*i) = -300*i;
% end
% d = numel(X);
% for i=1:2
%         X(d+1+1*(i-1):d+1*i) = [X(83)]-(600+300*i)*cos(dip*(pi/180))*sin(30*(pi/180));
%         Y(d+1+1*(i-1):d+1*i) = [Y(83)]-(600+300*i)*cos(dip*(pi/180))*cos(30*(pi/180));
%         Z(d+1+1*(i-1):d+1*i) = -600-300*i;
% end
% 
% % d = numel(X);
% % e = -Z(numel(Z));
% % for i=1
% %         X(d+1+26*(i-1):d+26*i) = [X(6:3:83)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
% %         Y(d+1+26*(i-1):d+26*i) = [Y(6:3:83)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
% %         Z(d+1+26*(i-1):d+26*i) = -e-900*i;
% % end
% % d = numel(X);
% % e = -Z(numel(Z));
% % for i=1
% %         X(d+1+20*(i-1):d+20*i) = [X(6:4:83)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
% %         Y(d+1+20*(i-1):d+20*i) = [Y(6:4:83)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
% %         Z(d+1+20*(i-1):d+20*i) = -e-1200*i;
% % end
% % d = numel(X);
% % e = -Z(numel(Z));
% % for i=1
% %         X(d+1+10*(i-1):d+10*i) = [X(6:8:83)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
% %         Y(d+1+10*(i-1):d+10*i) = [Y(6:8:83)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
% %         Z(d+1+10*(i-1):d+10*i) = -e-2400*i;
% % end
% 
% % Triangular Mesh
% XYZgex1(:,1) = X;XYZgex1(:,2) = Y;XYZgex1(:,3) = Z;
% 
% CONgex1=Delaunay2_5D(XYZgex1);
% 
% figure
% plot3(XYZgex1(:,1),XYZgex1(:,2),XYZgex1(:,3),'k.');
% % % xlabel('E-W(m)','fontsize',12)
% % % ylabel('N-S(m)','fontsize',12)
% axis equal;grid on
% % title('Chilliwack River Fault','fontsize',12)
% hold on
% 
% for i=1:numel(CONgex1(:,1))
%     plot3(XYZgex1([CONgex1(i,:) CONgex1(i,1)],1),XYZgex1([CONgex1(i,:) CONgex1(i,1)],2),XYZgex1([CONgex1(i,:) CONgex1(i,1)],3),'b-')
% end
% 
% for i=1:numel(CON(:,1))
%     plot3(XYZgcf([CON(i,:) CON(i,1)],1),XYZgcf([CON(i,:) CON(i,1)],2),XYZgcf([CON(i,:) CON(i,1)],3),'b-')
% end
% 
% [tngex1,nvecgex1] = PlotTriNormals(CONgex1,XYZgex1,convention);