% MB_Plot_3D_Loomis_Mountain_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% loomis mountain fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Loomis_Mountain_Fault_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dx = data.data(12,1) - data.data(1,1);
dy = data.data(12,2) - data.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+12*(i-1):d+12*i) = x(1:12)-300*i*cos(dip*(pi/180))*cos(theta);
        y(d+1+12*(i-1):d+12*i) = y(1:12)+300*i*cos(dip*(pi/180))*sin(theta);
        z(d+1+12*(i-1):d+12*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:2:12];set(6) = 12;
for i=1
        x(d+1+6*(i-1):d+6*i) = x(set)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        y(d+1+6*(i-1):d+6*i) = y(set)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        z(d+1+6*(i-1):d+6*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+5*(i-1):d+5*i) = [x(1:3:12);x(12)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        y(d+1+5*(i-1):d+5*i) = [y(1:3:12);y(12)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        z(d+1+5*(i-1):d+5*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+4*(i-1):d+4*i) = [x(1:4:12);x(12)]-(e+1500*i)*cos(dip*(pi/180))*cos(theta);
        y(d+1+4*(i-1):d+4*i) = [y(1:4:12);y(12)]+(e+1500*i)*cos(dip*(pi/180))*sin(theta);
        z(d+1+4*(i-1):d+4*i) = -e-1500*i;
end


% Triangular Mesh
XYZlmf(:,1) = x;XYZlmf(:,2) = y;XYZlmf(:,3) = z;

CON=Delaunay2_5D(XYZlmf);

figure
plot3(XYZlmf(:,1),XYZlmf(:,2),XYZlmf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Loomis Mountain Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZlmf([CON(i,:) CON(i,1)],1),XYZlmf([CON(i,:) CON(i,1)],2),XYZlmf([CON(i,:) CON(i,1)],3),'b-')
end

[tnlmf,nveclmf] = PlotTriNormals(CON,XYZlmf,convention);

% Translate back to UTM
XYZlmf(:,1) = XYZlmf(:,1) + xo;
XYZlmf(:,2) = XYZlmf(:,2) + yo;