% MB_Plot_3D_Loomis_Mountain_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% loomis mountain fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Loomis_Mountain_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:4:12);xs(12)];
y = [ys(1:4:12);ys(12)];
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dx = data.data(12,1) - data.data(1,1);
dy = data.data(12,2) - data.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+5*(i-1):d+5*i) = [xs(1:3:12);xs(12)]-1500*i*cos(dip*(pi/180))*cos(theta);
        y(d+1+5*(i-1):d+5*i) = [ys(1:3:12);ys(12)]+1500*i*cos(dip*(pi/180))*sin(theta);
        z(d+1+5*(i-1):d+5*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+7*(i-1):d+7*i) = [xs(1:2:12);xs(12)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        y(d+1+7*(i-1):d+7*i) = [ys(1:2:12);ys(12)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        z(d+1+7*(i-1):d+7*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+12*(i-1):d+12*i) = xs(1:12)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        y(d+1+12*(i-1):d+12*i) = ys(1:12)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        z(d+1+12*(i-1):d+12*i) = -(e+300*i);
end


% Triangular Mesh
XYZlmf(:,1) = x;XYZlmf(:,2) = y;XYZlmf(:,3) = z;

CON=Delaunay2_5D(XYZlmf);

figure
plot3(XYZlmf(:,1),XYZlmf(:,2),XYZlmf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Loomis Mountain Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZlmf([CON(i,:) CON(i,1)],1),XYZlmf([CON(i,:) CON(i,1)],2),XYZlmf([CON(i,:) CON(i,1)],3),'b-')
end

[tnlmf,nveclmf] = PlotTriNormals(CON,XYZlmf,convention);

% Translate back to UTM
XYZlmf(:,1) = XYZlmf(:,1) + xo;
XYZlmf(:,2) = XYZlmf(:,2) + yo;