% MB_Plot_3D_Mount_Watson_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% mount watson fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Mount_Watson_Fault_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% southern fault leg 3000m spacing
for i=1:3
    x(d+1+3*(i-1):d+3*i) = x(1:3)+3000*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+3*(i-1):d+3*i) = y(1:3)-3000*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+3*(i-1):d+3*i) = -3000*i;
end

d = numel(x);
% southern L. medium fault leg 1500m spacing
for i=1:3
    x(d+1+1*(i-1):d+1*i) = x(4)+1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = y(4)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -1500*i;
end

d = numel(x);
% southern U. medium fault leg 600m spacing
for i=1:3
    x(d+1+2*(i-1):d+2*i) = x(5:6)+600*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = y(5:6)-600*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -600*i;
end

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+33*(i-1):d+33*i) = x(7:39)+300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+33*(i-1):d+33*i) = y(7:39)-300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+33*(i-1):d+33*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+17*(i-1):d+17*i) = x(7:2:39)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+17*(i-1):d+17*i) = y(7:2:39)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+17*(i-1):d+17*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
x(d+1) = x(38)+e*cos(dip*(pi/180))*sin(theta);
y(d+1) = y(38)-e*cos(dip*(pi/180))*cos(theta);
z(d+1) = -e;
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+12*(i-1):d+12*i) = [x(7:3:39);x(39)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+12*(i-1):d+12*i) = [y(7:3:39);y(39)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+12*(i-1):d+12*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
x(d+1) = x(27)+e*cos(dip*(pi/180))*sin(theta);
y(d+1) = y(27)-e*cos(dip*(pi/180))*cos(theta);
z(d+1) = -e;
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+11*(i-1):d+11*i) = [x(7:8:39);x(11);x(20);x(26);x(28);x(35);x(37)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+11*(i-1):d+11*i) = [y(7:8:39);y(11);y(20);y(26);y(28);y(35);y(37)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+11*(i-1):d+11*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+11*(i-1):d+11*i) = [x(7:8:39);x(11);x(20);x(26);x(28);x(35);x(37)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+11*(i-1):d+11*i) = [y(7:8:39);y(11);y(20);y(26);y(28);y(35);y(37)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+11*(i-1):d+11*i) = -e-2400*i;
end
d = numel(x);
e = -z(numel(z));
set = [7:10:39];set(4) = 32;
for i=1
        x(d+1+5*(i-1):d+5*i) = [x(set);x(39)]+(e+3000*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = [y(set);y(39)]-(e+3000*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -e-3000*i;
end
% d = numel(x);
% e = -z(numel(z));
% x(d+1) = x(25)+e*cos(dip*(pi/180))*sin(theta);
% y(d+1) = y(25)-e*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -e;
% d = numel(x);
% e = -z(numel(z));
% x(d+1) = x(26)+e*cos(dip*(pi/180))*sin(theta);
% y(d+1) = y(26)-e*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -e;
% d = numel(x);
% e = -z(numel(z));
% x(d+1) = x(28)+e*cos(dip*(pi/180))*sin(theta);
% y(d+1) = y(28)-e*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -e;
% d = numel(x);
% e = -z(numel(z));
% x(d+1) = x(35)+e*cos(dip*(pi/180))*sin(theta);
% y(d+1) = y(35)-e*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -e;
% d = numel(x);
% e = -z(numel(z));
% x(d+1) = x(37)+e*cos(dip*(pi/180))*sin(theta);
% y(d+1) = y(37)-e*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -e;
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+5*(i-1):d+5*i) = x(7:8:39)+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+5*(i-1):d+5*i) = y(7:8:39)-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+5*(i-1):d+5*i) = -e-2400*i;
% end
% d = numel(x);
% e = -z(numel(z));
% x(d+1) = x(26)+e*cos(dip*(pi/180))*sin(theta);
% y(d+1) = y(26)-e*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -e;

% Triangular Mesh
XYZmwf(:,1) = x;XYZmwf(:,2) = y;XYZmwf(:,3) = z;

CON=Delaunay2_5D(XYZmwf);

figure
plot3(XYZmwf(:,1),XYZmwf(:,2),XYZmwf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Mount Watson Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZmwf([CON(i,:) CON(i,1)],1),XYZmwf([CON(i,:) CON(i,1)],2),XYZmwf([CON(i,:) CON(i,1)],3),'b-')
end

[tnmwf,nvecmwf] = PlotTriNormals(CON,XYZmwf,convention);

% Translate back to UTM
XYZmwf(:,1) = XYZmwf(:,1) + xo;
XYZmwf(:,2) = XYZmwf(:,2) + yo;