% MB_Plot_3D_Mount_Watson_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% mount watson fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Mount_Watson_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:3);xs(7:4:39)];xs(18) = xs(18)+50;xs(21) = xs(21)+50;xs(29) = xs(29)+50;xs(28) = xs(28)+25;xs(30) = xs(30)+25;
y = [ys(1:3);ys(7:4:39)];
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% southern fault leg 3000m spacing
for i=1:3
    x(d+1+3*(i-1):d+3*i) = xs(1:3)+3000*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+3*(i-1):d+3*i) = ys(1:3)-3000*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+3*(i-1):d+3*i) = -3000*i;
end

d = numel(x);
% southern L. medium fault leg 1500m spacing
for i=1:5
    x(d+1+1*(i-1):d+1*i) = xs(4)+(1500*i-1500)*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(4)-(1500*i-1500)*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -(1500*i-1500);
end

d = numel(x);
% southern U. medium fault leg 600m spacing
for i=1:7
    x(d+1+1*(i-1):d+1*i) = xs(5)+(600+600*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(5)-(600+600*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -(600+600*i);
end
d = numel(x);
for i=1:5
    x(d+1+1*(i-1):d+1*i) = xs(6)+(1500+600*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(6)-(1500+600*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -(1500+600*i);
end

d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+9*(i-1):d+9*i) = xs(7:4:39)+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+9*(i-1):d+9*i) = ys(7:4:39)-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+9*(i-1):d+9*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+17*(i-1):d+17*i) = xs(7:2:39)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+17*(i-1):d+17*i) = ys(7:2:39)-(e+600*i)*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+17*(i-1):d+17*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+33*(i-1):d+33*i) = xs(7:39)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+33*(i-1):d+33*i) = ys(7:39)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+33*(i-1):d+33*i) = -e-300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+17*(i-1):d+17*i) = xs(7:2:39)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+17*(i-1):d+17*i) = ys(7:2:39)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+17*(i-1):d+17*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
x(d+1) = xs(38)+e*cos(dip*(pi/180))*sin(theta);
y(d+1) = ys(38)-e*cos(dip*(pi/180))*cos(theta);
z(d+1) = -e;
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+12*(i-1):d+12*i) = [xs(7:3:39);xs(39)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+12*(i-1):d+12*i) = [ys(7:3:39);ys(39)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+12*(i-1):d+12*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
x(d+1) = xs(27)+e*cos(dip*(pi/180))*sin(theta);
y(d+1) = ys(27)-e*cos(dip*(pi/180))*cos(theta);
z(d+1) = -e;
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+11*(i-1):d+11*i) = [xs(7:8:39);xs(11);xs(20);xs(26);xs(28);xs(35);xs(37)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+11*(i-1):d+11*i) = [ys(7:8:39);ys(11);ys(20);ys(26);ys(28);ys(35);ys(37)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+11*(i-1):d+11*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+11*(i-1):d+11*i) = [xs(7:8:39);xs(11);xs(20);xs(26);xs(28);xs(35);xs(37)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+11*(i-1):d+11*i) = [ys(7:8:39);ys(11);ys(20);ys(26);ys(28);ys(35);ys(37)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+11*(i-1):d+11*i) = -e-2400*i;
end



% Triangular Mesh
XYZmwf(:,1) = x;XYZmwf(:,2) = y;XYZmwf(:,3) = z;

CON=Delaunay2_5D(XYZmwf);

figure
plot3(XYZmwf(:,1),XYZmwf(:,2),XYZmwf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Mount Watson Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZmwf([CON(i,:) CON(i,1)],1),XYZmwf([CON(i,:) CON(i,1)],2),XYZmwf([CON(i,:) CON(i,1)],3),'b-')
end

[tnmwf,nvecmwf] = PlotTriNormals(CON,XYZmwf,convention);

% Translate back to UTM
XYZmwf(:,1) = XYZmwf(:,1) + xo;
XYZmwf(:,2) = XYZmwf(:,2) + yo;