% MB_Plot_3D_Nooksack_River1_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Nooksack River fault1 %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Nooksack_River_Fault1_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
theta = 75*(pi/180);

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+19*(i-1):d+19*i) = x(1:19)+300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+19*(i-1):d+19*i) = y(1:19)-300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+19*(i-1):d+19*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+10*(i-1):d+10*i) = x(1:2:19)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+10*(i-1):d+10*i) = y(1:2:19)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+10*(i-1):d+10*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+7*(i-1):d+7*i) = x(1:3:19)+(e+750*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+7*(i-1):d+7*i) = y(1:3:19)-(e+750*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+7*(i-1):d+7*i) = -e-750*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+4*(i-1):d+4*i) = x(1:6:19)+(e+750*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = y(1:6:19)-(e+750*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -e-750*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+4*(i-1):d+4*i) = x(1:6:19)+(e+3000*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = y(1:6:19)-(e+3000*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -e-3000*i;
end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+4*(i-1):d+4*i) = x(1:6:19)+(e+3000*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+4*(i-1):d+4*i) = y(1:6:19)-(e+3000*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+4*(i-1):d+4*i) = -e-3000*i;
% end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+4*(i-1):d+4*i) = [x(1:8:19);x(19)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+4*(i-1):d+4*i) = [y(1:8:19);y(19)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+4*(i-1):d+4*i) = -e-2400*i;
% end

% Triangular Mesh
XYZnrf1(:,1) = x;XYZnrf1(:,2) = y;XYZnrf1(:,3) = z;

CON=Delaunay2_5D(XYZnrf1);

figure
plot3(XYZnrf1(:,1),XYZnrf1(:,2),XYZnrf1(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Nooksack River Fault1','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZnrf1([CON(i,:) CON(i,1)],1),XYZnrf1([CON(i,:) CON(i,1)],2),XYZnrf1([CON(i,:) CON(i,1)],3),'b-')
end

[tnnrf1,nvecnrf1] = PlotTriNormals(CON,XYZnrf1,convention);

% Translate back to UTM
XYZnrf1(:,1) = XYZnrf1(:,1) + xo;
XYZnrf1(:,2) = XYZnrf1(:,2) + yo;