% MB_Plot_3D_Nooksack_River2_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Nooksack River fault1 %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Nooksack_River_Fault2_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dx = data.data(8,1) - data.data(1,1);
dy = data.data(1,2) - data.data(8,2);
theta = atan(dy/dx);
% theta = 75*(pi/180);

% d = numel(x);
% % northern fault leg 3000m spacing
% for i=1:3
%     x(d+1+2*(i-1):d+2*i) = x(1:2)+3000*i*cos(dip*(pi/180))*sin(theta);
%     y(d+1+2*(i-1):d+2*i) = y(1:2)+3000*i*cos(dip*(pi/180))*cos(theta);
%     z(d+1+2*(i-1):d+2*i) = -3000*i;
% end

d = numel(x);
% northern U. medium fault leg 1500m spacing
for i=1:3
    x(d+1+2*(i-1):d+2*i) = x(1:2)-1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = y(1:2)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -1500*i;
end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1:6
    x(d+1+1*(i-1):d+1*i) = x(4)-750*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = y(4)-750*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -750*i;
end

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+4*(i-1):d+4*i) = x(5:8)-300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = y(5:8)-300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+2*(i-1):d+2*i) = [x(6);x(8)]-(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+2*(i-1):d+2*i) = [y(6);y(8)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+2*(i-1):d+2*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:2
        x(d+1+1*(i-1):d+1*i) = x(8)-(e+1500*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+1*(i-1):d+1*i) = y(8)-(e+1500*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+1*(i-1):d+1*i) = -e-1500*i;
end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+2*(i-1):d+2*i) = x(5:3:8)-(e+900*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+2*(i-1):d+2*i) = y(5:3:8)-(e+900*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+2*(i-1):d+2*i) = -e-900*i;
% end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+1*(i-1):d+1*i) = x(8)-(e+1200*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+1*(i-1):d+1*i) = y(8)-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+1*(i-1):d+1*i) = -e-1200*i;
% end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+1*(i-1):d+1*i) = x(8)-(e+2400*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+1*(i-1):d+1*i) = y(8)-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+1*(i-1):d+1*i) = -e-2400*i;
% end

% Triangular Mesh
XYZnrf2(:,1) = x;XYZnrf2(:,2) = y;XYZnrf2(:,3) = z;

CON=Delaunay2_5D(XYZnrf2);

figure
plot3(XYZnrf2(:,1),XYZnrf2(:,2),XYZnrf2(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Nooksack River Fault2','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZnrf2([CON(i,:) CON(i,1)],1),XYZnrf2([CON(i,:) CON(i,1)],2),XYZnrf2([CON(i,:) CON(i,1)],3),'b-')
end

[tnnrf2,nvecnrf2] = PlotTriNormals(CON,XYZnrf2,convention);

% Translate back to UTM
XYZnrf2(:,1) = XYZnrf2(:,1) + xo;
XYZnrf2(:,2) = XYZnrf2(:,2) + yo;