% MB_Plot_3D_Nooksack_River3a_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Nooksack River fault3a %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Nooksack_River_Fault3a_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = xs(1:4:11);x(3) = xs(11);
y = ys(1:4:11);y(3) = ys(11);
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
theta = 7*(pi/180);

d = numel(x);
% middle fault leg 300m spacing
set = [1:3:11];set(4) = 11;
for i=1
        x(d+1+4*(i-1):d+4*i) = xs(set)+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = ys(set)-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+6*(i-1):d+6*i) = xs(1:2:11)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+6*(i-1):d+6*i) = ys(1:2:11)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+6*(i-1):d+6*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+11*(i-1):d+11*i) = xs(1:11)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+11*(i-1):d+11*i) = ys(1:11)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+11*(i-1):d+11*i) = -(e+300*i);
end
d = numel(x);
e = -z(numel(z));

% set = [1:3:11];set(4) = 11;
% for i=1
%         x(d+1+4*(i-1):d+4*i) = x(set)+(e+900*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+4*(i-1):d+4*i) = y(set)-(e+900*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+4*(i-1):d+4*i) = -e-900*i;
% end


% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+3*(i-1):d+3*i) = [x(1);x(6);x(11)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+3*(i-1):d+3*i) = [y(1);y(6);y(11)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+3*(i-1):d+3*i) = -e-2400*i;
% end


% Triangular Mesh
XYZnrf3a(:,1) = x;XYZnrf3a(:,2) = y;XYZnrf3a(:,3) = z;

CON=Delaunay2_5D(XYZnrf3a);

figure
plot3(XYZnrf3a(:,1),XYZnrf3a(:,2),XYZnrf3a(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Nooksack River Fault3a','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZnrf3a([CON(i,:) CON(i,1)],1),XYZnrf3a([CON(i,:) CON(i,1)],2),XYZnrf3a([CON(i,:) CON(i,1)],3),'b-')
end

[tnnrf3a,nvecnrf3a] = PlotTriNormals(CON,XYZnrf3a,convention);

% Translate back to UTM
XYZnrf3a(:,1) = XYZnrf3a(:,1) + xo;
XYZnrf3a(:,2) = XYZnrf3a(:,2) + yo;