% MB_Plot_3D_Nooksack_River3b_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Nooksack River fault3a %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Nooksack_River_Fault3b_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
theta = 7*(pi/180);

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+13*(i-1):d+13*i) = x(1:13)+300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+13*(i-1):d+13*i) = y(1:13)-300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+13*(i-1):d+13*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:2:13];set(5) = 8;
for i=1
        x(d+1+7*(i-1):d+7*i) = x(set)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+7*(i-1):d+7*i) = y(set)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+7*(i-1):d+7*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:3:13];set(3) = 8;
for i=1
        x(d+1+5*(i-1):d+5*i) = x(set)+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = y(set)-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:4:13];set(3) = 8;
for i=1
        x(d+1+4*(i-1):d+4*i) = x(set)+(e+1500*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = y(set)-(e+1500*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -e-1500*i;
end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+3*(i-1):d+3*i) = [x(1);x(6);x(11)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+3*(i-1):d+3*i) = [y(1);y(6);y(11)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+3*(i-1):d+3*i) = -e-2400*i;
% end


% Triangular Mesh
XYZnrf3b(:,1) = x;XYZnrf3b(:,2) = y;XYZnrf3b(:,3) = z;

CON=Delaunay2_5D(XYZnrf3b);

figure
plot3(XYZnrf3b(:,1),XYZnrf3b(:,2),XYZnrf3b(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Nooksack River Fault3b','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZnrf3b([CON(i,:) CON(i,1)],1),XYZnrf3b([CON(i,:) CON(i,1)],2),XYZnrf3b([CON(i,:) CON(i,1)],3),'b-')
end

[tnnrf3b,nvecnrf3b] = PlotTriNormals(CON,XYZnrf3b,convention);

% Translate back to UTM
XYZnrf3b(:,1) = XYZnrf3b(:,1) + xo;
XYZnrf3b(:,2) = XYZnrf3b(:,2) + yo;