% MB_Plot_3D_North_Fork_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% North Fork fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('North_Fork_Fault_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to fault
theta = 10*(pi/180);

d = numel(x);
% northern fault leg 3000m spacing
for i=1:3
    x(d+1+3*(i-1):d+3*i) = x(1:3)-3000*i*cos(dip*(pi/180))*cos(theta);
    y(d+1+3*(i-1):d+3*i) = y(1:3)+3000*i*cos(dip*(pi/180))*sin(theta);
    z(d+1+3*(i-1):d+3*i) = -3000*i;
end

d = numel(x);
% northern U. medium fault leg 1500m spacing
for i=1:2
    x(d+1+2*(i-1):d+2*i) = x(4:5)-1500*i*cos(dip*(pi/180))*cos(theta);
    y(d+1+2*(i-1):d+2*i) = y(4:5)+1500*i*cos(dip*(pi/180))*sin(theta);
    z(d+1+2*(i-1):d+2*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:2
    x(d+1+1*(i-1):d+1*i) = x(5)-(e+3000*i)*cos(dip*(pi/180))*cos(theta);
    y(d+1+1*(i-1):d+1*i) = y(5)+(e+3000*i)*cos(dip*(pi/180))*sin(theta);
    z(d+1+1*(i-1):d+1*i) = -(e+3000*i);
end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1:3
    x(d+1+3*(i-1):d+3*i) = x(6:8)-600*i*cos(dip*(pi/180))*cos(theta);
    y(d+1+3*(i-1):d+3*i) = y(6:8)+600*i*cos(dip*(pi/180))*sin(theta);
    z(d+1+3*(i-1):d+3*i) = -600*i;
end

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+19*(i-1):d+19*i) = x(9:27)-300*i*cos(dip*(pi/180))*cos(theta);
        y(d+1+19*(i-1):d+19*i) = y(9:27)+300*i*cos(dip*(pi/180))*sin(theta);
        z(d+1+19*(i-1):d+19*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+10*(i-1):d+10*i) = [x(9:2:27)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        y(d+1+10*(i-1):d+10*i) = [y(9:2:27)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        z(d+1+10*(i-1):d+10*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+7*(i-1):d+7*i) = [x(9:3:27)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        y(d+1+7*(i-1):d+7*i) = [y(9:3:27)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        z(d+1+7*(i-1):d+7*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
set = [9:4:27];set(5) = 27;
for i=1
        x(d+1+5*(i-1):d+5*i) = [x(set)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        y(d+1+5*(i-1):d+5*i) = [y(set)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        z(d+1+5*(i-1):d+5*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
set = [9:8:27];set(3) = 27;
for i=1
        x(d+1+3*(i-1):d+3*i) = [x(set)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        y(d+1+3*(i-1):d+3*i) = [y(set)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        z(d+1+3*(i-1):d+3*i) = -e-2400*i;
end
d = numel(x);
e = -z(numel(z));
set = [9:8:27];set(3) = 27;
for i=1
        x(d+1+3*(i-1):d+3*i) = [x(set)]-(e+3000*i)*cos(dip*(pi/180))*cos(theta);
        y(d+1+3*(i-1):d+3*i) = [y(set)]+(e+3000*i)*cos(dip*(pi/180))*sin(theta);
        z(d+1+3*(i-1):d+3*i) = -e-3000*i;
end

% Triangular Mesh
XYZnff(:,1) = x;XYZnff(:,2) = y;XYZnff(:,3) = z;

CON=Delaunay2_5D(XYZnff);

figure
plot3(XYZnff(:,1),XYZnff(:,2),XYZnff(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('North Fork Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZnff([CON(i,:) CON(i,1)],1),XYZnff([CON(i,:) CON(i,1)],2),XYZnff([CON(i,:) CON(i,1)],3),'b-')
end

[tnnff,nvecnff] = PlotTriNormals(CON,XYZnff,convention);

% Translate back to UTM
XYZnff(:,1) = XYZnff(:,1) + xo;
XYZnff(:,2) = XYZnff(:,2) + yo;