% MB_Plot_3D_Rainbow_Creek_3km.m
clear all;close all

convention = 'z-';% PlotTriNormals vector direction
%% rainbow creek fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Rainbow_Creek_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:4:25);xs(20);xs(30)];x(6) = xs(22);xs(26) = xs(26)+10;
y = [ys(1:4:25);ys(20);ys(30)];y(6) = ys(22);
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to rainbow creek fault
% dx = data.data(1,1) - data.data(18,1);
% dy = data.data(18,2) - data.data(1,2);
% theta = atan(dx/dy);
theta = -1*(pi/180);

d = numel(x);
% middle fault leg 300m spacing
set = [1:4:25];set(6) = 22;
for i=1
        x(d+1+9*(i-1):d+9*i) = [xs(set);xs(30);xs(20)]+900*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+9*(i-1):d+9*i) = [ys(set);ys(30);ys(20)]+900*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+9*(i-1):d+9*i) = -900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+17*(i-1):d+17*i) = [xs(1:2:30);xs(30);xs(20)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+17*(i-1):d+17*i) = [ys(1:2:30);ys(30);ys(20)]+(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+17*(i-1):d+17*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+30*(i-1):d+30*i) = xs(1:30)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+30*(i-1):d+30*i) = ys(1:30)+(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+30*(i-1):d+30*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+30*(i-1):d+30*i) = xs(1:30)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+30*(i-1):d+30*i) = ys(1:30)+(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+30*(i-1):d+30*i) = -(e+300*i);
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+17*(i-1):d+17*i) = [xs(1:2:30);xs(30);xs(20)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+17*(i-1):d+17*i) = [ys(1:2:30);ys(30);ys(20)]+(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+17*(i-1):d+17*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:4:25];set(6) = 22;
for i=1
        x(d+1+9*(i-1):d+9*i) = [xs(set);xs(30);xs(20)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+9*(i-1):d+9*i) = [ys(set);ys(30);ys(20)]+(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+9*(i-1):d+9*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:8:30];set(3) = 14;
for i=1
        x(d+1+6*(i-1):d+6*i) = [xs(set);xs(30);xs(20)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+6*(i-1):d+6*i) = [ys(set);ys(30);ys(20)]+(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+6*(i-1):d+6*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+6*(i-1):d+6*i) = [xs(set);xs(30);xs(20)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+6*(i-1):d+6*i) = [ys(set);ys(30);ys(20)]+(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+6*(i-1):d+6*i) = -e-2400*i;
end


XYZracf(:,1) = x;XYZracf(:,2) = y;XYZracf(:,3) = z;

CON=Delaunay2_5D(XYZracf);

figure
plot3(XYZracf(:,1),XYZracf(:,2),XYZracf(:,3),'ko');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
% xlim([0 1000])
% ylim([0 6500])
% zlim([-3600 0])
title('Rainbow Creek Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZracf([CON(i,:) CON(i,1)],1),XYZracf([CON(i,:) CON(i,1)],2),XYZracf([CON(i,:) CON(i,1)],3),'b-')
end

[tnracf,nvecracf] = PlotTriNormals(CON,XYZracf,convention);

% Translate back to UTM
XYZracf(:,1) = XYZracf(:,1) + xo;
XYZracf(:,2) = XYZracf(:,2) + yo;