% MB_Plot_3D_Rocky_Creek_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% rocky creek fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Rocky_Creek_Fault_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+88*(i-1):d+88*i) = x(1:88)+300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+88*(i-1):d+88*i) = y(1:88)-300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+88*(i-1):d+88*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+45*(i-1):d+45*i) = [x(1:2:88);x(88)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+45*(i-1):d+45*i) = [y(1:2:88);y(88)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+45*(i-1):d+45*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+24*(i-1):d+24*i) = [x(1:4:88);x(88);x(75)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+24*(i-1):d+24*i) = [y(1:4:88);y(88);y(75)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+24*(i-1):d+24*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+13*(i-1):d+13*i) = [x(1:8:88);x(88);x(75)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+13*(i-1):d+13*i) = [y(1:8:88);y(88);y(75)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+13*(i-1):d+13*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+13*(i-1):d+13*i) = [x(1:8:88);x(88);x(75)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+13*(i-1):d+13*i) = [y(1:8:88);y(88);y(75)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+13*(i-1):d+13*i) = -e-2400*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+11*(i-1):d+11*i) = [x(1:10:88);x(88);x(75)]+(e+3000*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+11*(i-1):d+11*i) = [y(1:10:88);y(88);y(75)]-(e+3000*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+11*(i-1):d+11*i) = -e-3000*i;
end


XYZrcf(:,1) = x;XYZrcf(:,2) = y;XYZrcf(:,3) = z;

CON=Delaunay2_5D(XYZrcf);

figure
plot3(XYZrcf(:,1),XYZrcf(:,2),XYZrcf(:,3),'ko');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
% xlim([0 1000])
% ylim([0 6500])
% zlim([-3600 0])
title('Rocky Creek Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZrcf([CON(i,:) CON(i,1)],1),XYZrcf([CON(i,:) CON(i,1)],2),XYZrcf([CON(i,:) CON(i,1)],3),'b-')
end

[tnrcf,nvecrcf] = PlotTriNormals(CON,XYZrcf,convention);

% Translate back to UTM
XYZrcf(:,1) = XYZrcf(:,1) + xo;
XYZrcf(:,2) = XYZrcf(:,2) + yo;