% MB_Plot_3D_Ruth_Creek1_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Ruth Creek fault 1 %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Ruth_Creek_Fault1_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1);xs(3);xs(7:3:16)];
y = [ys(1);ys(3);ys(7:3:16)];
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

% d = numel(x);
% % northern fault leg 3000m spacing
% for i=1:3
%     x(d+1+2*(i-1):d+2*i) = x(1:2)+3000*i*cos(dip*(pi/180))*sin(theta);
%     y(d+1+2*(i-1):d+2*i) = y(1:2)-3000*i*cos(dip*(pi/180))*cos(theta);
%     z(d+1+2*(i-1):d+2*i) = -3000*i;
% end

% d = numel(x);
% % northern U. medium fault leg 1500m spacing
% for i=1:6
%     x(d+1+1*(i-1):d+1*i) = x(3)+1500*i*cos(dip*(pi/180))*sin(theta);
%     y(d+1+1*(i-1):d+1*i) = y(3)-1500*i*cos(dip*(pi/180))*cos(theta);
%     z(d+1+1*(i-1):d+1*i) = -1500*i;
% end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1
    x(d+1+2*(i-1):d+2*i) = [xs(1);xs(3)]+1200*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = [ys(1);ys(3)]-1200*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:5
    x(d+1+3*(i-1):d+3*i) = xs(1:3)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+3*(i-1):d+3*i) = ys(1:3)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+3*(i-1):d+3*i) = -(e+600*i);
end
d = numel(x);
e = -z(numel(z));
for i=1
    x(d+1+2*(i-1):d+2*i) = [xs(1);xs(3)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = [ys(1);ys(3)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -(e+1200*i);
end

d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+4*(i-1):d+4*i) = [xs(7:3:16)]+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = [ys(7:3:16)]-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+7*(i-1):d+7*i) = [xs(4:2:16)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+7*(i-1):d+7*i) = [ys(4:2:16)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+7*(i-1):d+7*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:5
        x(d+1+13*(i-1):d+13*i) = xs(4:16)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+13*(i-1):d+13*i) = ys(4:16)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+13*(i-1):d+13*i) = -(e+300*i);
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+7*(i-1):d+7*i) = xs(4:2:16)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+7*(i-1):d+7*i) = ys(4:2:16)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+7*(i-1):d+7*i) = -(e+300*i);
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+4*(i-1):d+4*i) = [xs(7:3:16)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = [ys(7:3:16)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+4*(i-1):d+4*i) = [xs(7:3:16)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = [ys(7:3:16)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -e-900*i;
end
% d = numel(x);
% e = -z(numel(z));
% for i=1:2
%         x(d+1+4*(i-1):d+4*i) = [x(7:3:16)]+(e+1500*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+4*(i-1):d+4*i) = [y(7:3:16)]-(e+1500*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+4*(i-1):d+4*i) = -e-1500*i;
% end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+5*(i-1):d+5*i) = [x(4:3:16)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+5*(i-1):d+5*i) = [y(4:3:16)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+5*(i-1):d+5*i) = -e-1200*i;
% end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+2*(i-1):d+2*i) = [x(6);x(13)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+2*(i-1):d+2*i) = [y(6);y(13)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+2*(i-1):d+2*i) = -e-2400*i;
% end

% Triangular Mesh
XYZrcf1(:,1) = x;XYZrcf1(:,2) = y;XYZrcf1(:,3) = z;

CON=Delaunay2_5D(XYZrcf1);

figure
plot3(XYZrcf1(:,1),XYZrcf1(:,2),XYZrcf1(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Chilliwack River Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZrcf1([CON(i,:) CON(i,1)],1),XYZrcf1([CON(i,:) CON(i,1)],2),XYZrcf1([CON(i,:) CON(i,1)],3),'b-')
end

[tnrcf1,nvecrcf1] = PlotTriNormals(CON,XYZrcf1,convention);

% Translate back to UTM
XYZrcf1(:,1) = XYZrcf1(:,1) + xo;
XYZrcf1(:,2) = XYZrcf1(:,2) + yo;