% MB_Plot_3D_Ruth_Creek2_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Ruth Creek fault 2 %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Ruth_Creek_Fault2_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:3);xs(8);xs(13);xs(18)];
y = [ys(1:3);ys(8);ys(13);ys(18)];
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

% d = numel(x);
% % northern fault leg 3000m spacing
% for i=1:3
%     x(d+1+2*(i-1):d+2*i) = x(1:2)+3000*i*cos(dip*(pi/180))*sin(theta);
%     y(d+1+2*(i-1):d+2*i) = y(1:2)-3000*i*cos(dip*(pi/180))*cos(theta);
%     z(d+1+2*(i-1):d+2*i) = -3000*i;
% end

d = numel(x);
% northern U. medium fault leg 1500m spacing
for i=1:4
    x(d+1+3*(i-1):d+3*i) = xs(1:3)+1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+3*(i-1):d+3*i) = ys(1:3)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+3*(i-1):d+3*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
    x(d+1+2*(i-1):d+2*i) = [xs(1);xs(3)]+(e+3000*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = [ys(1);ys(3)]-(e+3000*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -(e+3000*i);
end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1:3
    x(d+1+1*(i-1):d+1*i) = xs(4)+(1800+600*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(4)-(1800+600*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -(1800+600*i);
end

d = numel(x);
% middle fault leg 300m spacing
set = [5:4:18];set(4) = 18;
for i=1
        x(d+1+4*(i-1):d+4*i) = xs(set)+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = ys(set)-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+8*(i-1):d+8*i) = [xs(5:2:18);xs(18)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+8*(i-1):d+8*i) = [ys(5:2:18);ys(18)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+8*(i-1):d+8*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+14*(i-1):d+14*i) = xs(5:18)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+14*(i-1):d+14*i) = ys(5:18)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+14*(i-1):d+14*i) = -(e+300*i);
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+8*(i-1):d+8*i) = [xs(5:2:18);xs(18)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+8*(i-1):d+8*i) = [ys(5:2:18);ys(18)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+8*(i-1):d+8*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
set = [5:3:18];set(5) = 18;
for i=1
        x(d+1+5*(i-1):d+5*i) = [xs(set)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = [ys(set)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
set = [5:4:18];set(4) = 18;
for i=1
        x(d+1+4*(i-1):d+4*i) = [xs(set)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = [ys(set)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+3*(i-1):d+3*i) = [xs(5:8:18);xs(18)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+3*(i-1):d+3*i) = [ys(5:8:18);ys(18)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+3*(i-1):d+3*i) = -e-2400*i;
end

% Triangular Mesh
XYZrcf2(:,1) = x;XYZrcf2(:,2) = y;XYZrcf2(:,3) = z;

CON=Delaunay2_5D(XYZrcf2);

figure
plot3(XYZrcf2(:,1),XYZrcf2(:,2),XYZrcf2(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Ruth Creek Fault 2','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZrcf2([CON(i,:) CON(i,1)],1),XYZrcf2([CON(i,:) CON(i,1)],2),XYZrcf2([CON(i,:) CON(i,1)],3),'b-')
end

[tnrcf2,nvecrcf2] = PlotTriNormals(CON,XYZrcf2,convention);

% Translate back to UTM
XYZrcf2(:,1) = XYZrcf2(:,1) + xo;
XYZrcf2(:,2) = XYZrcf2(:,2) + yo;