% MB_Plot_3D_Shuksan_Thrust1_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Shuksan Thrust Fault 1 %%

dip = 50;
dip2 = 80;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Shuksan_Thrust_Fault1_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
theta = 0;

% dx = x(numel(x)) - x(1);dy = y(1) - y(numel(y));
% theta = atan(dx/dy);


d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+21*(i-1):d+21*i) = x(1:21)-300*i*cos(dip*(pi/180))*cos(theta);
        y(d+1+21*(i-1):d+21*i) = y(1:21)-300*i*cos(dip*(pi/180))*sin(theta);
        z(d+1+21*(i-1):d+21*i) = -300*i;
end



% Triangular Mesh
XYZwcf1(:,1) = x;XYZwcf1(:,2) = y;XYZwcf1(:,3) = z;

CON=Delaunay2_5D(XYZwcf1);

figure
plot3(XYZwcf1(:,1),XYZwcf1(:,2),XYZwcf1(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Shuksan Thrust Fault 1','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZwcf1([CON(i,:) CON(i,1)],1),XYZwcf1([CON(i,:) CON(i,1)],2),XYZwcf1([CON(i,:) CON(i,1)],3),'b-')
end

[tnwcf1,nvecwcf1] = PlotTriNormals(CON,XYZwcf1,convention);

% Translate back to UTM
XYZwcf1(:,1) = XYZwcf1(:,1) + xo;
XYZwcf1(:,2) = XYZwcf1(:,2) + yo;