% MB_Plot_3D_Slate_Mountain_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% slate mountain fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Slate_Mountain_Fault_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
theta = 75*(pi/180);

% d = numel(x);
% % northern fault leg 3000m spacing
% for i=1:3
%     x(d+1+3*(i-1):d+3*i) = x(1:3)+3000*i*cos(dip*(pi/180))*sin(theta);
%     y(d+1+3*(i-1):d+3*i) = y(1:3)-3000*i*cos(dip*(pi/180))*cos(theta);
%     z(d+1+3*(i-1):d+3*i) = -3000*i;
% end
% 
% d = numel(x);
% % northern U. medium fault leg 1500m spacing
% for i=1:6
%     x(d+1+1*(i-1):d+1*i) = x(4)+1500*i*cos(dip*(pi/180))*sin(theta);
%     y(d+1+1*(i-1):d+1*i) = y(4)-1500*i*cos(dip*(pi/180))*cos(theta);
%     z(d+1+1*(i-1):d+1*i) = -1500*i;
% end
% 
% d = numel(x);
% % northern L. medium fault leg 600m spacing
% for i=1:8
%     x(d+1+2*(i-1):d+2*i) = x(5:6)+600*i*cos(dip*(pi/180))*sin(theta);
%     y(d+1+2*(i-1):d+2*i) = y(5:6)-600*i*cos(dip*(pi/180))*cos(theta);
%     z(d+1+2*(i-1):d+2*i) = -600*i;
% end

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+17*(i-1):d+17*i) = x(1:17)+300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+17*(i-1):d+17*i) = y(1:17)-300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+17*(i-1):d+17*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+9*(i-1):d+9*i) = x(1:2:17)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+9*(i-1):d+9*i) = y(1:2:17)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+9*(i-1):d+9*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:3:17];set(6) = 17;
for i=1
        x(d+1+6*(i-1):d+6*i) = x(set)+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+6*(i-1):d+6*i) = y(set)-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+6*(i-1):d+6*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+5*(i-1):d+5*i) = x(1:4:17)+(e+1500*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = y(1:4:17)-(e+1500*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -e-1500*i;
end


% Triangular Mesh
XYZsmf(:,1) = x;XYZsmf(:,2) = y;XYZsmf(:,3) = z;

CON=Delaunay2_5D(XYZsmf);

figure
plot3(XYZsmf(:,1),XYZsmf(:,2),XYZsmf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Slate Mountain Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZsmf([CON(i,:) CON(i,1)],1),XYZsmf([CON(i,:) CON(i,1)],2),XYZsmf([CON(i,:) CON(i,1)],3),'b-')
end

[tnsmf,nvecsmf] = PlotTriNormals(CON,XYZsmf,convention);

% Translate back to UTM
XYZsmf(:,1) = XYZsmf(:,1) + xo;
XYZsmf(:,2) = XYZsmf(:,2) + yo;