% MB_Plot_3D_South_Fork_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% South Fork fault %%

dip = 80;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('South_Fork_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:3);xs(4);xs(9)];
y = [ys(1:3);ys(4);ys(9)];
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to fault
dataTCF = importdata('Thunder_Creek_Fault_points.csv');
dx = dataTCF.data(29,1) - dataTCF.data(1,1);
dy = dataTCF.data(29,2) - dataTCF.data(1,2);
theta = atan(dy/dx);

% d = numel(x);
% % northern fault leg 3000m spacing
% for i=1:3
%     x(d+1+2*(i-1):d+2*i) = x(1:2)+3000*i*cos(dip*(pi/180))*sin(theta);
%     y(d+1+2*(i-1):d+2*i) = y(1:2)-3000*i*cos(dip*(pi/180))*cos(theta);
%     z(d+1+2*(i-1):d+2*i) = -3000*i;
% end

d = numel(x);
% northern U. medium fault leg 1500m spacing
for i=1:4
    x(d+1+4*(i-1):d+4*i) = xs(1:4)-1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+4*(i-1):d+4*i) = ys(1:4)+1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+4*(i-1):d+4*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
    x(d+1+2*(i-1):d+2*i) = [xs(1);xs(3)]-(e+3000*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = [ys(1);ys(3)]+(e+3000*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -(e+3000*i);
end
d = numel(x);
for i=1
    x(d+1+1*(i-1):d+1*i) = xs(4)-9000*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(4)+9000*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -9000*i;
end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%     x(d+1+1*(i-1):d+1*i) = xs(4)-(e+3000*i)*cos(dip*(pi/180))*sin(theta);
%     y(d+1+1*(i-1):d+1*i) = ys(4)+(e+3000*i)*cos(dip*(pi/180))*cos(theta);
%     z(d+1+1*(i-1):d+1*i) = -(e+3000*i);
% end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1:5
    x(d+1+2*(i-1):d+2*i) = xs(5:6)-(1500+600*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = ys(5:6)+(1500+600*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -(1500+600*i);
end

d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+2*(i-1):d+2*i) = [xs(9);xs(6)]-1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+2*(i-1):d+2*i) = [ys(9);ys(6)]+1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+2*(i-1):d+2*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+2*(i-1):d+2*i) = xs(7:2:9)-(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+2*(i-1):d+2*i) = ys(7:2:9)+(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+2*(i-1):d+2*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:7
        x(d+1+3*(i-1):d+3*i) = xs(7:9)-(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+3*(i-1):d+3*i) = ys(7:9)+(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+3*(i-1):d+3*i) = -(e+300*i);
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+2*(i-1):d+2*i) = xs(7:2:9)-(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+2*(i-1):d+2*i) = ys(7:2:9)+(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+2*(i-1):d+2*i) = -e-300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:2
        x(d+1+2*(i-1):d+2*i) = [xs(9);xs(6)]-(e+750*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+2*(i-1):d+2*i) = [ys(9);ys(6)]+(e+750*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+2*(i-1):d+2*i) = -e-750*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+1*(i-1):d+1*i) = xs(9)-(e+3000*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+1*(i-1):d+1*i) = ys(9)+(e+3000*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+1*(i-1):d+1*i) = -e-3000*i;
end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+1*(i-1):d+1*i) = xs(9)-(e+2400*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+1*(i-1):d+1*i) = ys(9)+(e+2400*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+1*(i-1):d+1*i) = -e-2400*i;
% end
% d = numel(x);
% for i=1
%         x(d+1+1*(i-1):d+1*i) = xs(6)-6000*i*cos(dip*(pi/180))*sin(theta);
%         y(d+1+1*(i-1):d+1*i) = ys(6)+6000*i*cos(dip*(pi/180))*cos(theta);
%         z(d+1+1*(i-1):d+1*i) = -6000*i;
% end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+1*(i-1):d+1*i) = [x(9)]-(e+3000*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+1*(i-1):d+1*i) = [y(9)]+(e+3000*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+1*(i-1):d+1*i) = -e-3000*i;
% end

% Triangular Mesh
XYZsff(:,1) = x;XYZsff(:,2) = y;XYZsff(:,3) = z;

CON=Delaunay2_5D(XYZsff);

figure
plot3(XYZsff(:,1),XYZsff(:,2),XYZsff(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('South Fork Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZsff([CON(i,:) CON(i,1)],1),XYZsff([CON(i,:) CON(i,1)],2),XYZsff([CON(i,:) CON(i,1)],3),'b-')
end

[tnsff,nvecsff] = PlotTriNormals(CON,XYZsff,convention);

% Translate back to UTM
XYZsff(:,1) = XYZsff(:,1) + xo;
XYZsff(:,2) = XYZsff(:,2) + yo;