% MB_Plot_3D_StraightCreek.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% straight creek fault %%

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Straight_Creek_Fault_points.csv');
% x surface points
dx = data.data(1,1)-data.data(2,1);
x = [data.data(2,1):dx/2:data.data(1,1)];
x = sort(x,'descend');
dx = data.data(2,1)-data.data(3,1);
x(4:13) = [data.data(3,1):dx/10:data.data(2,1)-dx/10];
x(4:13) = sort(x(4:13),'descend');
dx = data.data(3,1)-data.data(4,1);
x(14:25) = [data.data(4,1):dx/12:data.data(3,1)-dx/12];
x(14:25) = sort(x(14:25),'descend');
dx = data.data(4,1)-data.data(5,1);
x(26:33) = [data.data(5,1):dx/8:data.data(4,1)-dx/8];
x(26:33) = sort(x(26:33),'descend');
dx = data.data(5,1)-data.data(6,1);
x(34:43) = [data.data(6,1):dx/10:data.data(5,1)-dx/10];
x(34:43) = sort(x(34:43),'descend');
x=x';
% y surface points
dy = data.data(2,2)-data.data(1,2);
y = [data.data(1,2):dy/2:data.data(2,2)];
dy = data.data(3,2)-data.data(2,2);
y(4:13) = [data.data(2,2)+dy/10:dy/10:data.data(3,2)];
dy = data.data(4,2)-data.data(3,2);
y(14:25) = [data.data(3,2)+dy/12:dy/12:data.data(4,2)];
dy = data.data(5,2)-data.data(4,2);
y(26:33) = [data.data(4,2)+dy/8:dy/8:data.data(5,2)];
dy = data.data(6,2)-data.data(5,2);
y(34:43) = [data.data(5,2)+dy/10:dy/10:data.data(6,2)];
y=y';
% z surface points
z = -ones(numel(x),1);

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

% southern fault leg 5000m spacing
x(44:55) = x(1:12)+5000*cos(80*(pi/180))*sin(theta);
x(56:67) = x(1:12)+10000*cos(80*(pi/180))*sin(theta);
x(68:79) = x(1:12)+15000*cos(80*(pi/180))*sin(theta);
y(44:55) = y(1:12)-5000*cos(80*(pi/180))*cos(theta);
y(56:67) = y(1:12)-10000*cos(80*(pi/180))*cos(theta);
y(68:79) = y(1:12)-15000*cos(80*(pi/180))*cos(theta);
z(44:55) = -5000;
z(56:67) = -10000;
z(68:79) = -15000;

% northern fault leg 5000m spacing
x(80:89) = x(34:43)+5000*cos(80*(pi/180))*sin(theta);
x(90:99) = x(34:43)+10000*cos(80*(pi/180))*sin(theta);
x(100:109) = x(34:43)+15000*cos(80*(pi/180))*sin(theta);
y(80:89) = y(34:43)-5000*cos(80*(pi/180))*cos(theta);
y(90:99) = y(34:43)-10000*cos(80*(pi/180))*cos(theta);
y(100:109) = y(34:43)-15000*cos(80*(pi/180))*cos(theta);
z(80:89) = -5000;
z(90:99) = -10000;
z(100:109) = -15000;

% middle fault leg 2500m spacing
x(110:130) = x(13:33)+2500*cos(80*(pi/180))*sin(theta);
x(131:151) = x(13:33)+5000*cos(80*(pi/180))*sin(theta);
x(152:172) = x(13:33)+7500*cos(80*(pi/180))*sin(theta);
x(173:193) = x(13:33)+10000*cos(80*(pi/180))*sin(theta);
x(194:214) = x(13:33)+12500*cos(80*(pi/180))*sin(theta);
x(215:235) = x(13:33)+15000*cos(80*(pi/180))*sin(theta);

y(110:130) = y(13:33)-2500*cos(80*(pi/180))*cos(theta);
y(131:151) = y(13:33)-5000*cos(80*(pi/180))*cos(theta);
y(152:172) = y(13:33)-7500*cos(80*(pi/180))*cos(theta);
y(173:193) = y(13:33)-10000*cos(80*(pi/180))*cos(theta);
y(194:214) = y(13:33)-12500*cos(80*(pi/180))*cos(theta);
y(215:235) = y(13:33)-15000*cos(80*(pi/180))*cos(theta);

z(110:130) = -2500;
z(131:151) = -5000;
z(152:172) = -7500;
z(173:193) = -10000;
z(194:214) = -12500;
z(215:235) = -15000;


XYZscf(:,1) = x;XYZscf(:,2) = y;XYZscf(:,3) = z;

CON=Delaunay2_5D(XYZscf);

figure
plot3(XYZscf(:,1),XYZscf(:,2),XYZscf(:,3),'ko');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
% xlim([0 1000])
% ylim([0 6500])
% zlim([-3600 0])
title('Straight Creek Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZscf([CON(i,:) CON(i,1)],1),XYZscf([CON(i,:) CON(i,1)],2),XYZscf([CON(i,:) CON(i,1)],3),'b-')
end

[tnscf,nvecscf] = PlotTriNormals(CON,XYZscf,convention);

% Translate back to UTM
XYZscf(:,1) = XYZscf(:,1) + xo;
XYZscf(:,2) = XYZscf(:,2) + yo;