% MB_Plot_3D_Swift_Creek1_200m.m
clear all;close all

convention = 'z-';% PlotTriNormals vector direction
%% swift creek fault 1 %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Swift_Creek_Fault1_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to rainbow creek fault
% datarc = importdata('Rainbow_Creek_Fault_points.csv');
% dx = datarc.data(1,1) - datarc.data(18,1);
% dy = datarc.data(18,2) - datarc.data(1,2);
% theta = atan(dx/dy);
theta = -1*(pi/180);

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+16*(i-1):d+16*i) = x(1:16)+300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+16*(i-1):d+16*i) = y(1:16)+300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+16*(i-1):d+16*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+9*(i-1):d+9*i) = [x(1:2:16);x(16)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+9*(i-1):d+9*i) = [y(1:2:16);y(16)]+(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+9*(i-1):d+9*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:3:16];set(4) = 11;
for i=1
        x(d+1+6*(i-1):d+6*i) = x(set)+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+6*(i-1):d+6*i) = y(set)+(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+6*(i-1):d+6*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+4*(i-1):d+4*i) = x(1:5:16)+(e+1500*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = y(1:5:16)+(e+1500*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -e-1500*i;
end


XYZscf1(:,1) = x;XYZscf1(:,2) = y;XYZscf1(:,3) = z;

CON=Delaunay2_5D(XYZscf1);

figure
plot3(XYZscf1(:,1),XYZscf1(:,2),XYZscf1(:,3),'ko');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
% xlim([0 1000])
% ylim([0 6500])
% zlim([-3600 0])
title('Swift Creek Fault 1','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZscf1([CON(i,:) CON(i,1)],1),XYZscf1([CON(i,:) CON(i,1)],2),XYZscf1([CON(i,:) CON(i,1)],3),'b-')
end

[tnscf1,nvecscf1] = PlotTriNormals(CON,XYZscf1,convention);

% Translate back to UTM
XYZscf1(:,1) = XYZscf1(:,1) + xo;
XYZscf1(:,2) = XYZscf1(:,2) + yo;