% MB_Plot_3D_Swift_Creek3_3km.m
clear all;close all

convention = 'z-';% PlotTriNormals vector direction
%% swift creek fault 2 %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Swift_Creek_Fault3_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:4:15);xs(15)];
y = [ys(1:4:15);ys(15)];
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to rainbow creek fault
% datarc = importdata('Rainbow_Creek_Fault_points.csv');
% dx = datarc.data(1,1) - datarc.data(18,1);
% dy = datarc.data(18,2) - datarc.data(1,2);
% theta = atan(dx/dy);
theta = -1*(pi/180);

d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+6*(i-1):d+6*i) = [xs(1:3:15);xs(15)]+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+6*(i-1):d+6*i) = [ys(1:3:15);ys(15)]+1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+6*(i-1):d+6*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+8*(i-1):d+8*i) = [xs(1:2:15)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+8*(i-1):d+8*i) = [ys(1:2:15)]+(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+8*(i-1):d+8*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+15*(i-1):d+15*i) = xs(1:15)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+15*(i-1):d+15*i) = ys(1:15)+(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+15*(i-1):d+15*i) = -(e+300*i);
end


XYZscf3(:,1) = x;XYZscf3(:,2) = y;XYZscf3(:,3) = z;

CON=Delaunay2_5D(XYZscf3);

figure
plot3(XYZscf3(:,1),XYZscf3(:,2),XYZscf3(:,3),'ko');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
% xlim([0 1000])
% ylim([0 6500])
% zlim([-3600 0])
title('Swift Creek Fault 3','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZscf3([CON(i,:) CON(i,1)],1),XYZscf3([CON(i,:) CON(i,1)],2),XYZscf3([CON(i,:) CON(i,1)],3),'b-')
end

[tnscf3,nvecscf3] = PlotTriNormals(CON,XYZscf3,convention);

% Translate back to UTM
XYZscf3(:,1) = XYZscf3(:,1) + xo;
XYZscf3(:,2) = XYZscf3(:,2) + yo;