% MB_Plot_3D_Table_Mountain_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% table mountain fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Table_Mountain_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:4:15);xs(15)];
y = [ys(1:4:15);ys(15)];
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
theta = 75*(pi/180);

d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+6*(i-1):d+6*i) = [xs(1:3:15);xs(15)]+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+6*(i-1):d+6*i) = [ys(1:3:15);ys(15)]-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+6*(i-1):d+6*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+8*(i-1):d+8*i) = xs(1:2:15)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+8*(i-1):d+8*i) = ys(1:2:15)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+8*(i-1):d+8*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+15*(i-1):d+15*i) = xs(1:15)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+15*(i-1):d+15*i) = ys(1:15)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+15*(i-1):d+15*i) = -(e+300*i);
end

% d = numel(x);
% e = -z(numel(z));
% 
% for i=1
%         x(d+1+5*(i-1):d+5*i) = [x(1:4:15);x(15)]+(e+1500*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+5*(i-1):d+5*i) = [y(1:4:15);y(15)]-(e+1500*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+5*(i-1):d+5*i) = -e-1500*i;
% end


% Triangular Mesh
XYZtmf(:,1) = x;XYZtmf(:,2) = y;XYZtmf(:,3) = z;

CON=Delaunay2_5D(XYZtmf);

figure
plot3(XYZtmf(:,1),XYZtmf(:,2),XYZtmf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Table Mountain Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZtmf([CON(i,:) CON(i,1)],1),XYZtmf([CON(i,:) CON(i,1)],2),XYZtmf([CON(i,:) CON(i,1)],3),'b-')
end

[tntmf,nvectmf] = PlotTriNormals(CON,XYZtmf,convention);

% Translate back to UTM
XYZtmf(:,1) = XYZtmf(:,1) + xo;
XYZtmf(:,2) = XYZtmf(:,2) + yo;