% MB_Plot_3D_Thompson_Creek_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Thompson Creek fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Thompson_Creek_Fault_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dx = data.data(1,1) - data.data(31,1);
dy = data.data(31,2) - data.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+31*(i-1):d+31*i) = x(1:31)+300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+31*(i-1):d+31*i) = y(1:31)+300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+31*(i-1):d+31*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+16*(i-1):d+16*i) = x(1:2:31)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+16*(i-1):d+16*i) = y(1:2:31)+(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+16*(i-1):d+16*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
% set = [1:3:11];set(4) = 11;
for i=1
        x(d+1+9*(i-1):d+9*i) = [x(1:4:31);x(31)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+9*(i-1):d+9*i) = [y(1:4:31);y(31)]+(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+9*(i-1):d+9*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+9*(i-1):d+9*i) = [x(1:4:31);x(31)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+9*(i-1):d+9*i) = [y(1:4:31);y(31)]+(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+9*(i-1):d+9*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+5*(i-1):d+5*i) = [x(1:8:31);x(31)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = [y(1:8:31);y(31)]+(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -e-2400*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+4*(i-1):d+4*i) = x(1:10:31)+(e+3000*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = y(1:10:31)+(e+3000*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -e-3000*i;
end


% Triangular Mesh
XYZtcf(:,1) = x;XYZtcf(:,2) = y;XYZtcf(:,3) = z;

CON=Delaunay2_5D(XYZtcf);

figure
plot3(XYZtcf(:,1),XYZtcf(:,2),XYZtcf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Thompson Creek Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZtcf([CON(i,:) CON(i,1)],1),XYZtcf([CON(i,:) CON(i,1)],2),XYZtcf([CON(i,:) CON(i,1)],3),'b-')
end

[tntcf,nvectcf] = PlotTriNormals(CON,XYZtcf,convention);

% Translate back to UTM
XYZtcf(:,1) = XYZtcf(:,1) + xo;
XYZtcf(:,2) = XYZtcf(:,2) + yo;