% MB_Plot_3D_Thunder_Creek_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Ruth Creek fault 2 %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Thunder_Creek_Fault_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to fault
dx = data.data(29,1) - data.data(1,1);
dy = data.data(29,2) - data.data(1,2);
theta = atan(dy/dx);

% d = numel(x);
% % northern fault leg 3000m spacing
% for i=1:3
%     x(d+1+2*(i-1):d+2*i) = x(1:2)+3000*i*cos(dip*(pi/180))*sin(theta);
%     y(d+1+2*(i-1):d+2*i) = y(1:2)-3000*i*cos(dip*(pi/180))*cos(theta);
%     z(d+1+2*(i-1):d+2*i) = -3000*i;
% end

% d = numel(x);
% % northern U. medium fault leg 1500m spacing
% for i=1:6
%     x(d+1+3*(i-1):d+3*i) = x(1:3)+1500*i*cos(dip*(pi/180))*sin(theta);
%     y(d+1+3*(i-1):d+3*i) = y(1:3)-1500*i*cos(dip*(pi/180))*cos(theta);
%     z(d+1+3*(i-1):d+3*i) = -1500*i;
% end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1:3
    x(d+1+3*(i-1):d+3*i) = x(1:3)-600*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+3*(i-1):d+3*i) = y(1:3)+600*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+3*(i-1):d+3*i) = -600*i;
end

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+26*(i-1):d+26*i) = x(4:29)-300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+26*(i-1):d+26*i) = y(4:29)+300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+26*(i-1):d+26*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+14*(i-1):d+14*i) = [x(4:2:29);x(29)]-(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+14*(i-1):d+14*i) = [y(4:2:29);y(29)]+(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+14*(i-1):d+14*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:3:29];set(10) = 29;
for i=1
        x(d+1+10*(i-1):d+10*i) = [x(set)]-(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+10*(i-1):d+10*i) = [y(set)]+(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+10*(i-1):d+10*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:4:29];%set(7) = 29;
for i=1
        x(d+1+8*(i-1):d+8*i) = [x(set)]-(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+8*(i-1):d+8*i) = [y(set)]+(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+8*(i-1):d+8*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:8:29];set(5) = 29;
for i=1
        x(d+1+5*(i-1):d+5*i) = [x(set)]-(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = [y(set)]+(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -e-2400*i;
end
d = numel(x);
e = -z(numel(z));
% set = [1:8:29];set(5) = 29;
for i=1
        x(d+1+4*(i-1):d+4*i) = [x(1:10:29);x(29)]-(e+3000*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = [y(1:10:29);y(29)]+(e+3000*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -e-3000*i;
end

% Triangular Mesh
XYZtcf(:,1) = x;XYZtcf(:,2) = y;XYZtcf(:,3) = z;

CON=Delaunay2_5D(XYZtcf);

figure
plot3(XYZtcf(:,1),XYZtcf(:,2),XYZtcf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Thunder Creek Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZtcf([CON(i,:) CON(i,1)],1),XYZtcf([CON(i,:) CON(i,1)],2),XYZtcf([CON(i,:) CON(i,1)],3),'b-')
end

[tntcf,nvectcf] = PlotTriNormals(CON,XYZtcf,convention);

% Translate back to UTM
XYZtcf(:,1) = XYZtcf(:,1) + xo;
XYZtcf(:,2) = XYZtcf(:,2) + yo;