% MB_Plot_3D_Twin_Sisters_Mountain_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% twin sisters mountain fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Sisters_Mountain_Fault_points.csv');
% x surface points
dx = data.data(1,1)-data.data(2,1);
x = [data.data(2,1):dx/12:data.data(1,1)];
x = sort(x,'descend');
x(14:51) = data.data(3:40,1);
x(14:51) = sort(x(14:51),'descend');
dx = data.data(40,1)-data.data(41,1);
x(52:55) = [data.data(41,1):dx/4:data.data(40,1)-dx/4];
x(52:55) = sort(x(52:55),'descend');
x=x';
% y surface points
dy = data.data(2,2)-data.data(1,2);
y = [data.data(1,2):dy/12:data.data(2,2)];
y(14:51) = data.data(3:40,2);
dy = data.data(41,2)-data.data(40,2);
y(52:55) = [data.data(40,2)+dy/4:dy/4:data.data(41,2)];
y=y';
% % z surface points
% z = -ones(numel(x),1);

xs = x;ys = y;xs(45) = xs(45)+25;xs(40) = xs(40)+20;xs(41) = xs(41)+20;xs(39) = xs(39)+10;xs(37) = xs(37)+20;
clear x;clear y;
x = [xs(1:15);xs(18:4:47);xs(47);xs(49:2:51);xs(52:55)];
y = [ys(1:15);ys(18:4:47);ys(47);ys(49:2:51);ys(52:55)];
z = -ones(numel(x),1);


figure
plot(x,y,'k.')
hold on
plot(data.data(:,1),data.data(:,2),'k*')
% plot(x(47),y(47),'r*','markersize',20)
axis equal

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% southern fault leg 5000m spacing
for i=1:2
    x(d+1+14*(i-1):d+14*i) = xs(1:14)+4500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+14*(i-1):d+14*i) = ys(1:14)-4500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+14*(i-1):d+14*i) = -4500*i;
end
d = numel(x);
x(d+1) = xs(14)+2250*cos(dip*(pi/180))*sin(theta);
y(d+1) = ys(14)-2250*cos(dip*(pi/180))*cos(theta);
z(d+1) = -2250;
d = numel(x);
x(d+1) = xs(14)+6750*cos(dip*(pi/180))*sin(theta);
y(d+1) = ys(14)-6750*cos(dip*(pi/180))*cos(theta);
z(d+1) = -6750;

d = numel(x);
% southern L. middle fault leg 1500m spacing
for i=1:3
    x(d+1+2*(i-1):d+2*i) = xs(15:16)+1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = ys(15:16)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -1500*i;
end
d = numel(x);
x(d+1) = xs(15)+6750*cos(dip*(pi/180))*sin(theta);
y(d+1) = ys(15)-6750*cos(dip*(pi/180))*cos(theta);
z(d+1) = -6750;
d = numel(x);
x(d+1) = xs(15)+9000*cos(dip*(pi/180))*sin(theta);
y(d+1) = ys(15)-9000*cos(dip*(pi/180))*cos(theta);
z(d+1) = -9000;
d = numel(x);
x(d+1) = xs(16)+6000*cos(dip*(pi/180))*sin(theta);
y(d+1) = ys(16)-6000*cos(dip*(pi/180))*cos(theta);
z(d+1) = -5625;

d = numel(x);
% southern U. middle fault leg 600m spacing
for i=1:4
    x(d+i) = xs(17)+(600*i+1800)*cos(dip*(pi/180))*sin(theta);
    y(d+i) = ys(17)-(600*i+1800)*cos(dip*(pi/180))*cos(theta);
    z(d+i) = -(600*i+1800);
end

d = numel(x);
% middle leg 300m spacing
% for i=1:13
%     x(d+1+30*(i-1):d+30*i) = x(18:47)+300*i*cos(dip*(pi/180))*sin(theta);
%     y(d+1+30*(i-1):d+30*i) = y(18:47)-300*i*cos(dip*(pi/180))*cos(theta);
%     z(d+1+30*(i-1):d+30*i) = -300*i;
% end
% d = numel(x);
% e = -z(numel(z));

for i=1
    x(d+1+9*(i-1):d+9*i) = [xs(18:4:47);xs(47)]+1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+9*(i-1):d+9*i) = [ys(18:4:47);ys(47)]-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+9*(i-1):d+9*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+16*(i-1):d+16*i) = [xs(18:2:47);xs(47)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+16*(i-1):d+16*i) = [ys(18:2:47);ys(47)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+16*(i-1):d+16*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
    x(d+1+30*(i-1):d+30*i) = xs(18:47)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+30*(i-1):d+30*i) = ys(18:47)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+30*(i-1):d+30*i) = -e-300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
    x(d+1+16*(i-1):d+16*i) = [xs(18:2:47);xs(47)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+16*(i-1):d+16*i) = [ys(18:2:47);ys(47)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+16*(i-1):d+16*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
    x(d+1+9*(i-1):d+9*i) = [xs(18:4:47);xs(47)]+(e+900*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+9*(i-1):d+9*i) = [ys(18:4:47);ys(47)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+9*(i-1):d+9*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
    x(d+1+9*(i-1):d+9*i) = [xs(18:4:47);xs(47)]+(e+1200*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+9*(i-1):d+9*i) = [ys(18:4:47);ys(47)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+9*(i-1):d+9*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+5*(i-1):d+5*i) = [xs(18:8:47);xs(47)]+(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = [ys(18:8:47);ys(47)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -e-2400*i;
end


% d = numel(x);
% x(d+1) = x(47)+4500*cos(dip*(pi/180))*sin(theta);
% y(d+1) = y(47)-4500*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -4500;
% d = numel(x);
% x(d+1) = x(47)+5400*cos(dip*(pi/180))*sin(theta);
% y(d+1) = y(47)-5400*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -5400;
% d = numel(x);
% x(d+1) = x(47)+6600*cos(dip*(pi/180))*sin(theta);
% y(d+1) = y(47)-6600*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -6600;
% d = numel(x);
% x(d+1) = x(47)+9000*cos(dip*(pi/180))*sin(theta);
% y(d+1) = y(47)-9000*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -9000;

d = numel(x);
% northern L. middle fault leg 600m spacing
for i=1:7
    x(d+1+1*(i-1):d+1*i) = xs(48)+(600*i+1200)*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(48)-(600*i+1200)*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -(600*i+1200);
end
d = numel(x);
for i=1:7
    x(d+1+1*(i-1):d+1*i) = xs(49)+(600*i+1200)*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(49)-(600*i+1200)*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -(600*i+1200);
end
d = numel(x);
x(d+1) = xs(49)+9000*cos(dip*(pi/180))*sin(theta);
y(d+1) = ys(49)-9000*cos(dip*(pi/180))*cos(theta);
z(d+1) = -9000;
d = numel(x);
x(d+1) = xs(49)+6000*cos(dip*(pi/180))*sin(theta);
y(d+1) = ys(49)-6000*cos(dip*(pi/180))*cos(theta);
z(d+1) = -6000;
% d = numel(x);
% x(d+1) = xs(49)+4500*cos(dip*(pi/180))*sin(theta);
% y(d+1) = ys(49)-4500*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -4500;
% d = numel(x);
% x(d+1) = x(48)+5400*cos(dip*(pi/180))*sin(theta);
% y(d+1) = y(48)-5400*cos(dip*(pi/180))*cos(theta);
% z(d+1) = -5400;

d = numel(x);
% northern U. middle fault leg 1500m spacing
for i=1:4
    x(d+1+1*(i-1):d+1*i) = xs(50)+1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(50)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -1500*i;
end
d = numel(x);
for i=1:4
    x(d+1+1*(i-1):d+1*i) = xs(51)+1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(51)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -1500*i;
end
d = numel(x);
x(d+1) = xs(51)+9000*cos(dip*(pi/180))*sin(theta);
y(d+1) = ys(51)-9000*cos(dip*(pi/180))*cos(theta);
z(d+1) = -9000;

d = numel(x);
% northern fault leg 3000m spacing
for i=1:3
    x(d+1+4*(i-1):d+4*i) = xs(52:55)+3000*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+4*(i-1):d+4*i) = ys(52:55)-3000*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+4*(i-1):d+4*i) = -3000*i;
end


XYZsmf(:,1) = x;XYZsmf(:,2) = y;XYZsmf(:,3) = z;

CON=Delaunay2_5D(XYZsmf);

figure
plot3(XYZsmf(:,1),XYZsmf(:,2),XYZsmf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
% xlim([0 1000])
% ylim([0 6500])
% zlim([-3600 0])
title('Twin Sisters Mountain Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZsmf([CON(i,:) CON(i,1)],1),XYZsmf([CON(i,:) CON(i,1)],2),XYZsmf([CON(i,:) CON(i,1)],3),'b-')
end
ylim([5.37e6 5.4e6])
xlim([5.7e5 5.9e5])

[tnsmf,nvecsmf] = PlotTriNormals(CON,XYZsmf,convention);

% Translate back to UTM
XYZsmf(:,1) = XYZsmf(:,1) + xo;
XYZsmf(:,2) = XYZsmf(:,2) + yo;