% MB_Plot_3D_Wanlick_Creek_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% wanlick creek fault %%

dip = 80;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Wanlick_Creek_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = xs(1:4:18);x(5) = xs(18);
y = ys(1:4:18);y(5) = ys(18);
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx);

d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+7*(i-1):d+7*i) = [xs(1:3:18);xs(18)]+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+7*(i-1):d+7*i) = [ys(1:3:18);ys(18)]-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+7*(i-1):d+7*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+10*(i-1):d+10*i) = [xs(1:2:18);xs(18)]+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+10*(i-1):d+10*i) = [ys(1:2:18);ys(18)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+10*(i-1):d+10*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+18*(i-1):d+18*i) = xs(1:18)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+18*(i-1):d+18*i) = ys(1:18)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+18*(i-1):d+18*i) = -(e+300*i);
end


% Triangular Mesh
XYZwcf(:,1) = x;XYZwcf(:,2) = y;XYZwcf(:,3) = z;

CON=Delaunay2_5D(XYZwcf);

figure
plot3(XYZwcf(:,1),XYZwcf(:,2),XYZwcf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Wanlick Creek Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZwcf([CON(i,:) CON(i,1)],1),XYZwcf([CON(i,:) CON(i,1)],2),XYZwcf([CON(i,:) CON(i,1)],3),'b-')
end

[tnwcf,nvecwcf] = PlotTriNormals(CON,XYZwcf,convention);

% Translate back to UTM
XYZwcf(:,1) = XYZwcf(:,1) + xo;
XYZwcf(:,2) = XYZwcf(:,2) + yo;