% MB_Plot_3D_Warm_Creek2_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% warm creek fault2 %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Warm_Creek_Fault2_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = xs(1:4:10);x(3) = xs(10);
y = ys(1:4:10);y(3) = ys(10);
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
theta = 75*(pi/180);

d = numel(x);
% middle fault leg 300m spacing
for i=1
        x(d+1+4*(i-1):d+4*i) = xs(1:3:10)+1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+4*(i-1):d+4*i) = ys(1:3:10)-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+4*(i-1):d+4*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
set = [1:2:10];set(5) = 10;
for i=1
        x(d+1+5*(i-1):d+5*i) = xs(set)+(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = ys(set)-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+10*(i-1):d+10*i) = xs(1:10)+(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+10*(i-1):d+10*i) = ys(1:10)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+10*(i-1):d+10*i) = -(e+300*i);
end


% Triangular Mesh
XYZwcf2(:,1) = x;XYZwcf2(:,2) = y;XYZwcf2(:,3) = z;

CON=Delaunay2_5D(XYZwcf2);

figure
plot3(XYZwcf2(:,1),XYZwcf2(:,2),XYZwcf2(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Warm Creek Fault 2','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZwcf2([CON(i,:) CON(i,1)],1),XYZwcf2([CON(i,:) CON(i,1)],2),XYZwcf2([CON(i,:) CON(i,1)],3),'b-')
end

[tnwcf2,nvecwcf2] = PlotTriNormals(CON,XYZwcf2,convention);

% Translate back to UTM
XYZwcf2(:,1) = XYZwcf2(:,1) + xo;
XYZwcf2(:,2) = XYZwcf2(:,2) + yo;