% MB_Plot_3D_Welker_Peak_Thrust_east1_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Welker Peak Thrust Fault east 1 %%

dip = 50;
dip2 = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Welker_Peak_Thrust_Fault_east1_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dataACF = importdata('Anderson_Creek_Fault_points.csv');
dx = dataACF.data(91,1) - dataACF.data(1,1);
dy = dataACF.data(91,2) - dataACF.data(1,2);
theta = atan(dy/dx) - atan(cos(dip2*(pi/180))/cos(dip*(pi/180)));


% dx = x(numel(x)) - x(1);dy = y(1) - y(numel(y));
% theta = atan(dx/dy);


d = 0;
% middle fault leg 300m spacing
for i=1:2
        X(d+1+25*(i-1):d+25*i) = x(1:25)+(2400+300*i)*cos(dip*(pi/180))*cos(theta);
        Y(d+1+25*(i-1):d+25*i) = y(1:25)+(2400+300*i)*cos(dip*(pi/180))*sin(theta);
        Z(d+1+25*(i-1):d+25*i) = -(2400+300*i);
end



% Triangular Mesh
XYZwcf1(:,1) = X;XYZwcf1(:,2) = Y;XYZwcf1(:,3) = Z;

CON=Delaunay2_5D(XYZwcf1);

figure
plot3(XYZwcf1(:,1),XYZwcf1(:,2),XYZwcf1(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Welker Peak Thrust Fault east1','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZwcf1([CON(i,:) CON(i,1)],1),XYZwcf1([CON(i,:) CON(i,1)],2),XYZwcf1([CON(i,:) CON(i,1)],3),'b-')
end

[tnwcf1,nvecwcf1] = PlotTriNormals(CON,XYZwcf1,convention);

% Translate back to UTM
XYZwcf1(:,1) = XYZwcf1(:,1) + xo;
XYZwcf1(:,2) = XYZwcf1(:,2) + yo;