% MB_Plot_3D_Winchester_200m.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Winchester fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Winchester_Fault_points.csv');
% x surface points
x = data.data(:,1);
% y surface points
y = data.data(:,2);
% z surface points
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dx = data.data(21,1) - data.data(1,1);
dy = data.data(1,2) - data.data(21,2);
theta = atan(dy/dx);
% theta = 75*(pi/180);

d = numel(x);
% northern fault leg 3000m spacing
for i=1:3
    x(d+1+2*(i-1):d+2*i) = x(1:2)-3000*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = y(1:2)-3000*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -3000*i;
end

d = numel(x);
% northern U. medium fault leg 1500m spacing
for i=1:4
    x(d+1+1*(i-1):d+1*i) = x(3)-1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = y(3)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -1500*i;
end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1:3
    x(d+1+2*(i-1):d+2*i) = x(4:5)-600*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = y(4:5)-600*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -600*i;
end

d = numel(x);
% middle fault leg 300m spacing
for i=1:3
        x(d+1+16*(i-1):d+16*i) = x(6:21)-300*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+16*(i-1):d+16*i) = y(6:21)-300*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+16*(i-1):d+16*i) = -300*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+9*(i-1):d+9*i) = [x(6:2:21);x(21)]-(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+9*(i-1):d+9*i) = [y(6:2:21);y(21)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+9*(i-1):d+9*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+6*(i-1):d+6*i) = [x(6:3:21)]-(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+6*(i-1):d+6*i) = [y(6:3:21)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+6*(i-1):d+6*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+3*(i-1):d+3*i) = [x(6:8:21);x(21)]-(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+3*(i-1):d+3*i) = [y(6:8:21);y(21)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+3*(i-1):d+3*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+3*(i-1):d+3*i) = [x(6:8:21);x(21)]-(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+3*(i-1):d+3*i) = [y(6:8:21);y(21)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+3*(i-1):d+3*i) = -e-2400*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+3*(i-1):d+3*i) = [x(6:10:21);x(21)]-(e+3000*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+3*(i-1):d+3*i) = [y(6:10:21);y(21)]-(e+3000*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+3*(i-1):d+3*i) = -e-3000*i;
end

% Triangular Mesh
XYZwf(:,1) = x;XYZwf(:,2) = y;XYZwf(:,3) = z;

CON=Delaunay2_5D(XYZwf);

figure
plot3(XYZwf(:,1),XYZwf(:,2),XYZwf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Winchester Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZwf([CON(i,:) CON(i,1)],1),XYZwf([CON(i,:) CON(i,1)],2),XYZwf([CON(i,:) CON(i,1)],3),'b-')
end

[tnwf,nvecwf] = PlotTriNormals(CON,XYZwf,convention);

% Translate back to UTM
XYZwf(:,1) = XYZwf(:,1) + xo;
XYZwf(:,2) = XYZwf(:,2) + yo;