% MB_Plot_3D_Winchester_3km.m
clear all;close all

% show_graph = 0;% Show graph of fit normal (0=no 1=yes)
% f = 1;% smoothing factor (0 to 1)
convention = 'z-';% PlotTriNormals vector direction
%% Winchester fault %%

dip = 60;

% local origin
xo = 0;
yo = 0;

% import data
data = importdata('Winchester_Fault_points.csv');
% x surface points
xs = data.data(:,1);
% y surface points
ys = data.data(:,2);

x = [xs(1:3);xs(6:8:21);xs(21)];
y = [ys(1:3);ys(6:8:21);ys(21)];
z = -ones(numel(x),1);

figure
plot(x,y,'k.')
axis equal

% projection angle orthagonal to anderson creek fault
dx = data.data(21,1) - data.data(1,1);
dy = data.data(1,2) - data.data(21,2);
theta = atan(dy/dx);
% theta = 75*(pi/180);

d = numel(x);
% northern fault leg 3000m spacing
for i=1:3
    x(d+1+2*(i-1):d+2*i) = xs(1:2)-3000*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = ys(1:2)-3000*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -3000*i;
end

d = numel(x);
% northern U. medium fault leg 1500m spacing
for i=1:4
    x(d+1+1*(i-1):d+1*i) = xs(3)-1500*i*cos(dip*(pi/180))*sin(theta);
    y(d+1+1*(i-1):d+1*i) = ys(3)-1500*i*cos(dip*(pi/180))*cos(theta);
    z(d+1+1*(i-1):d+1*i) = -1500*i;
end

d = numel(x);
% northern L. medium fault leg 600m spacing
for i=1:3
    x(d+1+2*(i-1):d+2*i) = xs(4:5)-(1800+600*i)*cos(dip*(pi/180))*sin(theta);
    y(d+1+2*(i-1):d+2*i) = ys(4:5)-(1800+600*i)*cos(dip*(pi/180))*cos(theta);
    z(d+1+2*(i-1):d+2*i) = -(1800+600*i);
end

% middle fault leg 300m spacing
d = numel(x);
for i=1
        x(d+1+5*(i-1):d+5*i) = [xs(6:4:21);xs(21)]-1500*i*cos(dip*(pi/180))*sin(theta);
        y(d+1+5*(i-1):d+5*i) = [ys(6:4:21);ys(21)]-1500*i*cos(dip*(pi/180))*cos(theta);
        z(d+1+5*(i-1):d+5*i) = -1500*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+9*(i-1):d+9*i) = [xs(6:2:21);xs(21)]-(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+9*(i-1):d+9*i) = [ys(6:2:21);ys(21)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+9*(i-1):d+9*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1:6
        x(d+1+16*(i-1):d+16*i) = xs(6:21)-(e+300*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+16*(i-1):d+16*i) = ys(6:21)-(e+300*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+16*(i-1):d+16*i) = -(e+300*i);
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+9*(i-1):d+9*i) = [xs(6:2:21);xs(21)]-(e+600*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+9*(i-1):d+9*i) = [ys(6:2:21);ys(21)]-(e+600*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+9*(i-1):d+9*i) = -e-600*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+6*(i-1):d+6*i) = [xs(6:3:21)]-(e+900*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+6*(i-1):d+6*i) = [ys(6:3:21)]-(e+900*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+6*(i-1):d+6*i) = -e-900*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+3*(i-1):d+3*i) = [xs(6:8:21);xs(21)]-(e+1200*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+3*(i-1):d+3*i) = [ys(6:8:21);ys(21)]-(e+1200*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+3*(i-1):d+3*i) = -e-1200*i;
end
d = numel(x);
e = -z(numel(z));
for i=1
        x(d+1+3*(i-1):d+3*i) = [xs(6:8:21);xs(21)]-(e+2400*i)*cos(dip*(pi/180))*sin(theta);
        y(d+1+3*(i-1):d+3*i) = [ys(6:8:21);ys(21)]-(e+2400*i)*cos(dip*(pi/180))*cos(theta);
        z(d+1+3*(i-1):d+3*i) = -e-2400*i;
end
% d = numel(x);
% e = -z(numel(z));
% for i=1
%         x(d+1+3*(i-1):d+3*i) = [xs(6:10:21);xs(21)]-(e+3000*i)*cos(dip*(pi/180))*sin(theta);
%         y(d+1+3*(i-1):d+3*i) = [ys(6:10:21);ys(21)]-(e+3000*i)*cos(dip*(pi/180))*cos(theta);
%         z(d+1+3*(i-1):d+3*i) = -e-3000*i;
% end

% Triangular Mesh
XYZwf(:,1) = x;XYZwf(:,2) = y;XYZwf(:,3) = z;

CON=Delaunay2_5D(XYZwf);

figure
plot3(XYZwf(:,1),XYZwf(:,2),XYZwf(:,3),'k.');
xlabel('E-W(m)','fontsize',12)
ylabel('N-S(m)','fontsize',12)
axis equal;grid on
title('Winchester Fault','fontsize',12)
hold on

for i=1:numel(CON(:,1))
    plot3(XYZwf([CON(i,:) CON(i,1)],1),XYZwf([CON(i,:) CON(i,1)],2),XYZwf([CON(i,:) CON(i,1)],3),'b-')
end

[tnwf,nvecwf] = PlotTriNormals(CON,XYZwf,convention);

% Translate back to UTM
XYZwf(:,1) = XYZwf(:,1) + xo;
XYZwf(:,2) = XYZwf(:,2) + yo;