function out = p3din_FAULT_func_v1_MB200m(E,nu,Stress,Pf,Bn,filename_in,xyz1,xyz2,xyz3,xyz4,xyz5,xyz6,xyz7,xyz8,xyz9,xyz10,xyz11,xyz12,xyz13,xyz14,xyz15,xyz16,xyz17,xyz18,xyz19,xyz20,xyz21,xyz22,xyz23,xyz24,xyz25,xyz26,xyz27,xyz28,xyz29,xyz30,xyz31,xyz32,xyz33,xyz34,xyz35,tn1,tn2,tn3,tn4,tn5,tn6,tn7,tn8,tn9,tn10,tn11,tn12,tn13,tn14,tn15,tn16,tn17,tn18,tn19,tn20,tn21,tn22,tn23,tn24,tn25,tn26,tn27,tn28,tn29,tn30,tn31,tn32,tn33,tn34,tn35,CS_WADGER,OBSgridWADGER200)

% Matlab script to create input for systematic analyses of fault meshes.
%
% PURPOSE: generate .in file for "newpoly3d" executable, 1999 C++ version
% v1
%
% 
% Author: J. Ole Kaven
% Date: 8/29/2003
% 
% Version: 1
% Modified By: Michael Swyer
% Date Modified: 6/27/2011
% 
% Input: < >
% Space: Half
% Comments:

% uncomment first line to treat this as a function. 

% close all
% clear all
scrsz = get(0,'Screensize');
out.vers = 1;
out.date = datestr(now); 
out.space = 'half'; % 'half' --> half space; 'full' = whole space

[fid,message] = fopen(filename_in,'w'); % replace this with variable to treat as function; can give the directory listing for thepoly3D folder



%% Setup stuff:
% Vertices (used to define mesh of "fault")
%   Note: must explicitly do for each fault object

% entriesX = mx4 matrix where m = # of elements.  X is fault number.  row 1 is element number, and rows 2-4 are x,y,z coordinates of element nodes
%   NOTE: must add the last vertex number of the previous fault to the all
%         the vertex numbers of the next fault to eliminate redundancy.

% fault01
entries1(1,:) = 1:(length(xyz1));
entries1(2:4,:) = xyz1';

% fault02
entries2(1,:) = (1+max(entries1(1,:))):(length(xyz2)+max(entries1(1,:)));% first number of this fault is after last number of first fault!!
entries2(2:4,:) = xyz2';

% fault03
entries3(1,:) = (1+max(entries2(1,:))):(length(xyz3)+max(entries2(1,:)));% first number of this fault is after last number of first fault!!
entries3(2:4,:) = xyz3';

% fault04
entries4(1,:) = (1+max(entries3(1,:))):(length(xyz4)+max(entries3(1,:)));% first number of this fault is after last number of first fault!!
entries4(2:4,:) = xyz4';

% fault05
entries5(1,:) = (1+max(entries4(1,:))):(length(xyz5)+max(entries4(1,:)));% first number of this fault is after last number of first fault!!
entries5(2:4,:) = xyz5';

% fault06
entries6(1,:) = (1+max(entries5(1,:))):(length(xyz6)+max(entries5(1,:)));% first number of this fault is after last number of first fault!!
entries6(2:4,:) = xyz6';

% fault07
entries7(1,:) = (1+max(entries6(1,:))):(length(xyz7)+max(entries6(1,:)));% first number of this fault is after last number of first fault!!
entries7(2:4,:) = xyz7';

% fault08
entries8(1,:) = (1+max(entries7(1,:))):(length(xyz8)+max(entries7(1,:)));% first number of this fault is after last number of first fault!!
entries8(2:4,:) = xyz8';

% fault09
entries9(1,:) = (1+max(entries8(1,:))):(length(xyz9)+max(entries8(1,:)));% first number of this fault is after last number of first fault!!
entries9(2:4,:) = xyz9';

% fault10
entries10(1,:) = (1+max(entries9(1,:))):(length(xyz10)+max(entries9(1,:)));% first number of this fault is after last number of first fault!!
entries10(2:4,:) = xyz10';

% fault11
entries11(1,:) = (1+max(entries10(1,:))):(length(xyz11)+max(entries10(1,:)));% first number of this fault is after last number of first fault!!
entries11(2:4,:) = xyz11';

% fault12
entries12(1,:) = (1+max(entries11(1,:))):(length(xyz12)+max(entries11(1,:)));% first number of this fault is after last number of first fault!!
entries12(2:4,:) = xyz12';

% fault13
entries13(1,:) = (1+max(entries12(1,:))):(length(xyz13)+max(entries12(1,:)));% first number of this fault is after last number of first fault!!
entries13(2:4,:) = xyz13';

% fault14
entries14(1,:) = (1+max(entries13(1,:))):(length(xyz14)+max(entries13(1,:)));% first number of this fault is after last number of first fault!!
entries14(2:4,:) = xyz14';

% fault15
entries15(1,:) = (1+max(entries14(1,:))):(length(xyz15)+max(entries14(1,:)));% first number of this fault is after last number of first fault!!
entries15(2:4,:) = xyz15';

% fault16
entries16(1,:) = (1+max(entries15(1,:))):(length(xyz16)+max(entries15(1,:)));% first number of this fault is after last number of first fault!!
entries16(2:4,:) = xyz16';

% fault17
entries17(1,:) = (1+max(entries16(1,:))):(length(xyz17)+max(entries16(1,:)));% first number of this fault is after last number of first fault!!
entries17(2:4,:) = xyz17';

% fault18
entries18(1,:) = (1+max(entries17(1,:))):(length(xyz18)+max(entries17(1,:)));% first number of this fault is after last number of first fault!!
entries18(2:4,:) = xyz18';

% fault19
entries19(1,:) = (1+max(entries18(1,:))):(length(xyz19)+max(entries18(1,:)));% first number of this fault is after last number of first fault!!
entries19(2:4,:) = xyz19';

% fault20
entries20(1,:) = (1+max(entries19(1,:))):(length(xyz20)+max(entries19(1,:)));% first number of this fault is after last number of first fault!!
entries20(2:4,:) = xyz20';

% fault21
entries21(1,:) = (1+max(entries20(1,:))):(length(xyz21)+max(entries20(1,:)));% first number of this fault is after last number of first fault!!
entries21(2:4,:) = xyz21';

% fault22
entries22(1,:) = (1+max(entries21(1,:))):(length(xyz22)+max(entries21(1,:)));% first number of this fault is after last number of first fault!!
entries22(2:4,:) = xyz22';

% fault23
entries23(1,:) = (1+max(entries22(1,:))):(length(xyz23)+max(entries22(1,:)));% first number of this fault is after last number of first fault!!
entries23(2:4,:) = xyz23';

% fault24
entries24(1,:) = (1+max(entries23(1,:))):(length(xyz24)+max(entries23(1,:)));% first number of this fault is after last number of first fault!!
entries24(2:4,:) = xyz24';

% fault25
entries25(1,:) = (1+max(entries24(1,:))):(length(xyz25)+max(entries24(1,:)));% first number of this fault is after last number of first fault!!
entries25(2:4,:) = xyz25';

% fault26
entries26(1,:) = (1+max(entries25(1,:))):(length(xyz26)+max(entries25(1,:)));% first number of this fault is after last number of first fault!!
entries26(2:4,:) = xyz26';

% fault27
entries27(1,:) = (1+max(entries26(1,:))):(length(xyz27)+max(entries26(1,:)));% first number of this fault is after last number of first fault!!
entries27(2:4,:) = xyz27';

% fault28
entries28(1,:) = (1+max(entries27(1,:))):(length(xyz28)+max(entries27(1,:)));% first number of this fault is after last number of first fault!!
entries28(2:4,:) = xyz28';

% fault29
entries29(1,:) = (1+max(entries28(1,:))):(length(xyz29)+max(entries28(1,:)));% first number of this fault is after last number of first fault!!
entries29(2:4,:) = xyz29';

% fault30
entries30(1,:) = (1+max(entries29(1,:))):(length(xyz30)+max(entries29(1,:)));% first number of this fault is after last number of first fault!!
entries30(2:4,:) = xyz30';

% fault31
entries31(1,:) = (1+max(entries30(1,:))):(length(xyz31)+max(entries30(1,:)));% first number of this fault is after last number of first fault!!
entries31(2:4,:) = xyz31';

% fault32
entries32(1,:) = (1+max(entries31(1,:))):(length(xyz32)+max(entries31(1,:)));% first number of this fault is after last number of first fault!!
entries32(2:4,:) = xyz32';

% fault33
entries33(1,:) = (1+max(entries32(1,:))):(length(xyz33)+max(entries32(1,:)));% first number of this fault is after last number of first fault!!
entries33(2:4,:) = xyz33';

% fault34
entries34(1,:) = (1+max(entries33(1,:))):(length(xyz34)+max(entries33(1,:)));% first number of this fault is after last number of first fault!!
entries34(2:4,:) = xyz34';

% deformation source
entries35(1,:) = (1+max(entries34(1,:))):(length(xyz35)+max(entries34(1,:)));% first number of this fault is after last number of first fault!!
entries35(2:4,:) = xyz35';

% **************************************************
% *Surfaces & Elements & Boundary Conditions (aux3)*                        % ******* TO SPECIFY ELEMENT B.C. MODIFY aux3 
% **************************************************

%   NOTE: traction boundary conditions are specified relative to the local
%         element normal. The normals are based on the polarity (order in which the
%         vertices are specified in dat.tri)

%   NOTE: must add the last vertex number of the previous fault to the all
%         the vertex numbers of the next fault to eliminate redundancy*

% fault01
aux3 = zeros(size(tn1)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault01 = [aux3 tn1]';clear aux3

% fault02
aux3 = zeros(size(tn2)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault02 = [aux3 (tn2+max(entries1(1,:)))]';clear aux3% *Note the addition of last element number*

% fault03
aux3 = zeros(size(tn3)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault03 = [aux3 (tn3+max(entries2(1,:)))]';clear aux3% *Note the addition of last element number*

% fault04
aux3 = zeros(size(tn4)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault04 = [aux3 (tn4+max(entries3(1,:)))]';clear aux3% *Note the addition of last element number*

% fault05
aux3 = zeros(size(tn5)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault05 = [aux3 (tn5+max(entries4(1,:)))]';clear aux3% *Note the addition of last element number*

% fault06
aux3 = zeros(size(tn6)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault06 = [aux3 (tn6+max(entries5(1,:)))]';clear aux3% *Note the addition of last element number*

% fault07
aux3 = zeros(size(tn7)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault07 = [aux3 (tn7+max(entries6(1,:)))]';clear aux3% *Note the addition of last element number*

% fault08
aux3 = zeros(size(tn8)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault08 = [aux3 (tn8+max(entries7(1,:)))]';clear aux3% *Note the addition of last element number*

% fault09
aux3 = zeros(size(tn9)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault09 = [aux3 (tn9+max(entries8(1,:)))]';clear aux3% *Note the addition of last element number*

% fault10
aux3 = zeros(size(tn10)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault10 = [aux3 (tn10+max(entries9(1,:)))]';clear aux3% *Note the addition of last element number*

% fault11
aux3 = zeros(size(tn11)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault11 = [aux3 (tn11+max(entries10(1,:)))]';clear aux3% *Note the addition of last element number*

% fault12
aux3 = zeros(size(tn12)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault12 = [aux3 (tn12+max(entries11(1,:)))]';clear aux3% *Note the addition of last element number*

% fault13
aux3 = zeros(size(tn13)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault13 = [aux3 (tn13+max(entries12(1,:)))]';clear aux3% *Note the addition of last element number*

% fault14
aux3 = zeros(size(tn14)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault14 = [aux3 (tn14+max(entries13(1,:)))]';clear aux3% *Note the addition of last element number*

% fault15
aux3 = zeros(size(tn15)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault15 = [aux3 (tn15+max(entries14(1,:)))]';clear aux3% *Note the addition of last element number*

% fault16
aux3 = zeros(size(tn16)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault16 = [aux3 (tn16+max(entries15(1,:)))]';clear aux3% *Note the addition of last element number*

% fault17
aux3 = zeros(size(tn17)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault17 = [aux3 (tn17+max(entries16(1,:)))]';clear aux3% *Note the addition of last element number*

% fault18
aux3 = zeros(size(tn18)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault18 = [aux3 (tn18+max(entries17(1,:)))]';clear aux3% *Note the addition of last element number*

% fault19
aux3 = zeros(size(tn19)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault19 = [aux3 (tn19+max(entries18(1,:)))]';clear aux3% *Note the addition of last element number*

% fault20
aux3 = zeros(size(tn20)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault20 = [aux3 (tn20+max(entries19(1,:)))]';clear aux3% *Note the addition of last element number*

% fault21
aux3 = zeros(size(tn21)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault21 = [aux3 (tn21+max(entries20(1,:)))]';clear aux3% *Note the addition of last element number*

% fault22
aux3 = zeros(size(tn22)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault22 = [aux3 (tn22+max(entries21(1,:)))]';clear aux3% *Note the addition of last element number*

% fault23
aux3 = zeros(size(tn23)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault23 = [aux3 (tn23+max(entries22(1,:)))]';clear aux3% *Note the addition of last element number*

% fault24
aux3 = zeros(size(tn24)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault24 = [aux3 (tn24+max(entries23(1,:)))]';clear aux3% *Note the addition of last element number*

% fault25
aux3 = zeros(size(tn25)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault25 = [aux3 (tn25+max(entries24(1,:)))]';clear aux3% *Note the addition of last element number*

% fault26
aux3 = zeros(size(tn26)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault26 = [aux3 (tn26+max(entries25(1,:)))]';clear aux3% *Note the addition of last element number*

% fault27
aux3 = zeros(size(tn27)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault27 = [aux3 (tn27+max(entries26(1,:)))]';clear aux3% *Note the addition of last element number*

% fault28
aux3 = zeros(size(tn28)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault28 = [aux3 (tn28+max(entries27(1,:)))]';clear aux3% *Note the addition of last element number*

% fault29
aux3 = zeros(size(tn29)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault29 = [aux3 (tn29+max(entries28(1,:)))]';clear aux3% *Note the addition of last element number*

% fault30
aux3 = zeros(size(tn30)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault30 = [aux3 (tn30+max(entries29(1,:)))]';clear aux3% *Note the addition of last element number*

% fault31
aux3 = zeros(size(tn31)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault31 = [aux3 (tn31+max(entries30(1,:)))]';clear aux3% *Note the addition of last element number*

% fault32
aux3 = zeros(size(tn32)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault32 = [aux3 (tn32+max(entries31(1,:)))]';clear aux3% *Note the addition of last element number*

% fault33
aux3 = zeros(size(tn33)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault33 = [aux3 (tn33+max(entries32(1,:)))]';clear aux3% *Note the addition of last element number*

% fault34
aux3 = zeros(size(tn34)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
fault34 = [aux3 (tn34+max(entries33(1,:)))]';clear aux3% *Note the addition of last element number*

% deformation source
aux3 = zeros(size(tn35)); % must double check dir of normals!     % mx3 array m = number of elements --> these first three columns are the traction or burgers vector BC on each element
aux3(:,3) = Bn;
fault35 = [aux3 (tn35+max(entries34(1,:)))]';clear aux3% *Note the addition of last element number*


% ***************
% *Stress Tensor*
% ***************
S11 = Stress(1,1);
S22 = Stress(2,2);
S33 = Stress(3,3);
S12 = Stress(1,2);
S13 = Stress(1,3);
S23 = Stress(2,3);


%% Generate .in file

fprintf(fid,'*******************************************************************************\n');
fprintf(fid,'*                            Section 1: CONSTANTS                             *\n');
fprintf(fid,'*******************************************************************************\n');
fprintf(fid,'* Titles\n');
fprintf(fid,'*--------\n');
fprintf(fid,'\n');
fprintf(fid,'title1 = "Two fault surfaces to model fault overlap."\n');
fprintf(fid,'\n');
fprintf(fid,'* Elastic Constants\n');
fprintf(fid,'* Specify any two. Leave the rest blank.\n');
fprintf(fid,'*----------------------------------------\n');
fprintf(fid,'shear_mod         =\n');
fprintf(fid,'psn_ratio         = %d\n',nu);                                 % <-- Input poisson's ratio
fprintf(fid,'youngs_mod        = %d\n',E);                                  % <-- Input Young's modulus                      
fprintf(fid,'bulk_mod          =\n');
fprintf(fid,'lame_lambda       =\n');
fprintf(fid,'\n');
fprintf(fid,'* Remote Stresses/Strains\n');
fprintf(fid,'rem_bc_type       = stress            *(stress/strain)\n');
fprintf(fid,'s11r              = %d\n',S11 + Pf);                           % <-- remote stress tensor, use a tensor transform in a MASTER function to define
fprintf(fid,'s22r              = %d\n',S22 + Pf);
fprintf(fid,'s33r              = %d\n',S33 + Pf);
fprintf(fid,'s12r              = %d\n',S12);
fprintf(fid,'s13r              = %d\n',S13);
fprintf(fid,'s23r              = %d\n',S23);
fprintf(fid,'\n');
fprintf(fid,'* Options\n'); 
fprintf(fid,'*---------\n');
fprintf(fid,'half_space        = yes                *(yes/no)\n');          % <-- for whole space replace "= yes" with "= no"
fprintf(fid,'check_cond_num    = yes               *(yes/no)\n');           % avoid numbers greater than 10^-8 or 10^-6
fprintf(fid,'print_elt_geom    = yes               *(yes/no)\n'); 
fprintf(fid,'elt_geom_csys     = global\n'); 
fprintf(fid,'null_value        = -999.0\n');
fprintf(fid,'\n');
fprintf(fid,'end *(CONSTANTS)\n');
fprintf(fid,'*******************************************************************************\n');
fprintf(fid,'*                        Section 2: USER COORDINATE SYSTEMS                   *\n');
fprintf(fid,'*******************************************************************************\n');
fprintf(fid,'* (1)        (2)     (3)    (4)    (5)     (6)     (7)     (8)       (9)\n');
fprintf(fid,'*name      parent    x1o    x2o    x3o    rot1    rot2    rot3    rot order\n');
fprintf(fid,'*--------- --------- ------ ------ ------ ------- ------- ------- ---------\n');
xcent = 0;ycent = 0;zcent = 0;rot1 = 0;	rot2 = 0;	rot3 = 0;
defaul = [xcent, ycent, zcent, rot1, rot2, rot3, 321]; 
fprintf(fid,'CrackCS    global %7.6f %7.6f %7.6f %7.1f %7.1f %7.1f %5.0f\n',defaul);
fprintf(fid,'CS_WADGER    global %7.6f %7.6f %7.6f %7.1f %7.1f %7.1f %5.0f\n',CS_WADGER);
fprintf(fid,'\n');
fprintf(fid,'end *(USER COORDINATE SYSTEMS)\n');
fprintf(fid,'*******************************************************************************\n');
fprintf(fid,'*                         Section 3: OBSERVATION GRIDS                        *\n');
fprintf(fid,'*******************************************************************************\n');
fprintf(fid,'* (1)    (2) (3)      (4)        (5)        (6)     (7)    (8)    (9)    (10)   (11)   (12) (13) (14) (15)\n');
fprintf(fid,'*name    dim outp  endpt csys obspt csys outp csys x1beg  x2beg  x3beg  x1end  x2end  x3end  nx1 nx2 nx3\n');
fprintf(fid,'*------- --- ----- ---------- ---------- --------- ------ ------ ------ ------ ------ ------ --- --- ---\n');
% replace first term as needed, where the number is the dimension: 1D "ObsLine 1", 2D "ObsPlane 2", 3D "ObsVol 3"
fprintf(fid,'OBSgridWADGER200 2  dsps   CS_WADGER     global     global    %5.7f  %5.7f  %5.7f  %5.7f  %5.7f  %5.7f  %d  %d  %d\n',OBSgridWADGER200); 
fprintf(fid,'\n');
fprintf(fid,'end *(OBSERVATION GRIDS)\n');
fprintf(fid,'*******************************************************************************\n');
fprintf(fid,'*                      Section 4: OBJECTS/ELEMENTS/VERTICES                   *\n');
fprintf(fid,'*                      (o = object, e = element, v = vertex)                  *\n');
fprintf(fid,'*******************************************************************************\n');
%%% Begin Fault Object 1
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Straight Creek Fault" bt      CrackCS  \n');                            % object name defined (note as defined above elocal (except for BC) are same as global by my choice
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
% "%4.0f" 4 decimal places before the decimal --> integer vertex; for
% "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries1);    
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
% note that the the BC are specified; e = element, 3 = 3 space dimensions,
% elocla --> BC are in element local: "bbb", b = bergers veger, t = traction, the next 3 numbers are BC magnitudes in dip,strike,normal
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault01);    
fprintf(fid,'\n');
%%% Begin Fault 2: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');                                              
fprintf(fid,'*- ---------------- ------- ----------\n');                                              
fprintf(fid,'o  "Anderson Creek Fault" bt      CrackCS  \n');                                                    
fprintf(fid,'\n');  
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries2);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault02);
fprintf(fid,'\n');
%%% Begin Fault 3: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Darrington-Devils Mountain Fault" bt      CrackCS  \n');
fprintf(fid,'\n');  
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries3);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault03);
fprintf(fid,'\n');
%%% Begin Fault 4: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Twin Sisters Mountain Fault" bt      CrackCS  \n');
fprintf(fid,'\n');  
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries4);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault04);
fprintf(fid,'\n');
%%% Begin Fault 5: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Rocky Creek Fault" bt      CrackCS  \n');
fprintf(fid,'\n');  
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries5);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault05);
fprintf(fid,'\n');
%%% Begin Fault 6: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Baker Lake Fault" bt      CrackCS  \n');
fprintf(fid,'\n');  
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries6);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault06);
fprintf(fid,'\n');
%%% Begin Fault 7: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Mount Watson Fault" bt      CrackCS  \n');
fprintf(fid,'\n');  
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries7);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault07);
fprintf(fid,'\n');
%%% Begin Fault 8: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Rainbow Creek Fault" bt      CrackCS  \n');
fprintf(fid,'\n');  
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries8);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault08);
fprintf(fid,'\n');
%%% Begin Fault 9: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Swift Creek Fault 1" bt      CrackCS  \n');
fprintf(fid,'\n');  
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries9);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault09);
fprintf(fid,'\n');
%%% Begin Fault 10: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Swift Creek Fault 2" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries10);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault10);
fprintf(fid,'\n');
%%% Begin Fault 11: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Swift Creek Fault 3" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries11);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault11);
fprintf(fid,'\n');
%%% Begin Fault 12: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Damfino Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries12);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault12);
fprintf(fid,'\n');
%%% Begin Fault 13: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Slate Mountain Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries13);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault13);
fprintf(fid,'\n');
%%% Begin Fault 14: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Barometer Mountain Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries14);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault14);
fprintf(fid,'\n');
%%% Begin Fault 15: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Table Mountain Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries15);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault15);
fprintf(fid,'\n');
%%% Begin Fault 16: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Winchester Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries16);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault16);
fprintf(fid,'\n');
%%% Begin Fault 17: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Nooksack River Fault 1" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries17);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault17);
fprintf(fid,'\n');
%%% Begin Fault 18: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Nooksack River Fault 2" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries18);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault18);
fprintf(fid,'\n');
%%% Begin Fault 19: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Nooksack River Fault 3a" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries19);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault19);
fprintf(fid,'\n');
%%% Begin Fault 20: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Nooksack River Fault 3b" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries20);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault20);
fprintf(fid,'\n');
%%% Begin Fault 21: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Thompson Creek Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries21);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault21);
fprintf(fid,'\n');
%%% Begin Fault 22: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Gallop Creek Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries22);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault22);
fprintf(fid,'\n');
%%% Begin Fault 23: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Warm Creek Fault 1" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries23);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault23);
fprintf(fid,'\n');
%%% Begin Fault 24: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Warm Creek Fault 2" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries24);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault24);
fprintf(fid,'\n');
%%% Begin Fault 25: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Loomis Mountain Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries25);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault25);
fprintf(fid,'\n');
%%% Begin Fault 26: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Wanlick Creek Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries26);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault26);
fprintf(fid,'\n');
%%% Begin Fault 27: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Chilliwack River Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries27);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault27);
fprintf(fid,'\n');
%%% Begin Fault 28: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Ruth Creek Fault 1" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries28);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault28);
fprintf(fid,'\n');
%%% Begin Fault 29: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Ruth Creek Fault 2" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries29);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault29);
fprintf(fid,'\n');
%%% Begin Fault 30: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Glacier Extensional Fault 1" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries30);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault30);
fprintf(fid,'\n');
%%% Begin Fault 31: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Glacier Extensional Fault 2" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries31);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault31);
fprintf(fid,'\n');
%%% Begin Fault 32: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Thunder Creek Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries32);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault32);
fprintf(fid,'\n');
%%% Begin Fault 33: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "South Fork Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries33);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault33);
fprintf(fid,'\n');
%%% Begin Fault 34: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "North Fork Fault" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries34);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    ttb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault34);
fprintf(fid,'\n');
%%% Begin Fault 35: this begins next "fault" --> 11 lines for each "fault object"
fprintf(fid,'*(1) (2)            (3)        (4)\n');                        
fprintf(fid,'*o name             outp    eltc csys\n');
fprintf(fid,'*- ---------------- ------- ----------\n');
fprintf(fid,'o  "Mount Baker Point Source Deformation" bt      CrackCS  \n');
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)     (3)       (4)         (5)         (6)\n');
fprintf(fid,'*v name     csys       x1          x2          x3\n');
fprintf(fid,'*- -------- ---------  ------      ------      ------\n');
fprintf(fid,'*Fracture vertices\n');
fprintf(fid,'v  %4.0f  global    %8.12f   %8.12f   %8.12f\n', entries35);    % "%4.0f" 4 decimal places before the decimal --> integer vertex; for "%8.8f" can be increased for greater precision, could also replace with %d
fprintf(fid,'\n');
fprintf(fid,'*(1) (2)   (3)      (4)    (5)       (6)       (7)      (8) (9) (10) (...)\n');
fprintf(fid,'*e #vert BC csys   BC type BC1       BC2       BC3       v1  v2  v3 ...\n');
fprintf(fid,'*- ----- --------- ------- --------- --------- --------- --  --  -- --\n');
fprintf(fid,'*BCs & connectivity \n');
fprintf(fid,'e  3     elocal    bbb   %5.5f     %5.5f     %5.5f      %4.0f %4.0f %4.0f\n', fault35);
fprintf(fid,'\n');
fprintf(fid,'\n');
fprintf(fid,'end *(OBJECTS/ELEMENTS/VERTICES)\n');
fclose(fid);
